// ###########################################################################
// File: ASMINLIN.H
// (c)Copyright 04/1996, Lepilleur Baptiste (Aka Elyon de Zuul Design)
// ###########################################################################


#ifndef ASMINLIN_H_INCLUDED
#define ASMINLIN_H_INCLUDED

// #######################Created: 04/04/96 19h09mn###########################
// Assembleur in-line:
// #####################Last change: 04/04/96 19h09mn#########################
#include <string.h>

#ifdef __WATCOMC__

// Copy DS value to ES & Save ES content on stack
void loadES(void);
#pragma aux loadES = \
" push ds"\
" pop es";

// VGA Set video mode
void dos_vga_setmode(SL mode);
#pragma aux dos_vga_setmode = "int 0x10" parm [eax];

// VESA set video mode
bool dos_vesa_setmode(SL mode);
#pragma aux dos_vesa_setmode = \
"       mov ax, 0x4f02        "\
"       int 10h               "\
"       cmp ax, 0x4f          "\
"       je ok                 "\
"       xor ax, ax            "\
"       jmp fin               "\
"ok:    mov al, 1             "\
"fin:                         "\
        parm [ebx]\
        value [al];


void video_setblinking(UB blink);
#pragma aux video_setblinking = \
"      mov ax, 1003h                          "\
"      int 10h                                "\
      parm [BL];

void video_50lines(void);
#pragma aux video_50lines = \
"      mov ax, 1114h                          "\
"      int 10h                                ";

void video_25lines(void);
#pragma aux video_25lines = \
"      mov ax, 1112h                          "\
"      int 10h                                ";

void video_setcurs(UW shape);
#pragma aux video_setcurs = \
"    mov ah, 1                                "\
"    int 10h                                  "\
    parm [CX];


// ***********************Created: 18/04/96 21h15mn***************************
// Set Cursor position
// *********************Last change: 18/04/96 21h15mn*************************
void cursor_setpos(UB xcurs, UB ycurs);
//                    DL        DH
#pragma aux cursor_setpos = "mov ah, 2 "\
                            "xor bx, bx"\
                            "int 0x10" parm [dl] [dh];


// ***********************Created: 04/04/96 19h13mn***************************
// Copy DS to ES (use by interrupt from realmode caller) (e.g. mouse)
// *********************Last change: 04/04/96 19h13mn*************************
// void load_es();
#pragma aux load_es =                  \
        "         push ds"             \
        "         pop  es";

// ***********************Created: 04/04/96 19h10mn***************************
// Fill memory with a word
// In:  dst -> start of array
//      c   -> the array is fill with this
//      nb  -> number of 'c' to put in the array
// *********************Last change: 04/04/96 19h10mn*************************
void memsetw(void *dst, UW c, UL nb);
//                EDI   EAX   ECX
#pragma aux memsetw =          \
"           shr ecx, 1        "\
"           jnc memsetwn1     "\
"           mov [edi], ax     "\
"           add edi, 2        "\
"           or  ecx, ecx      "\
"memsetwn1: jz  memsetwno     "\
"           mov bx, ax        "\
"           shl eax, 16       "\
"           mov ax, bx        "\
"           rep stosd         "\
"memsetwno:                   "\
            modify [eax bx ecx edi]\
            parm [edi] [AX] [ecx];

// ***********************Created: 04/04/96 19h20mn***************************
// Fill a array with a byte
// In:  dst -> array
//      c   -> byte used to  fill (decl. as UL for optimisation)
//      nb  -> number of byte to put in the array
// *********************Last change: 04/04/96 19h34mn*************************
// void memsetb(void *dst, UL c, UL nb);
//                   EDI   EAX   ECX
#pragma aux memsetb =          \
"           mov  ah, al        "\
"           mov  ebx, eax      "\
"           shl  eax, 16       "\
"           mov  ax, bx        "\
"           or   ecx, ecx      "\
"           mov  ebx, ecx      "\
"           jz   fmemsetb      "\
"lpalign4:  test edi, 3        "\
"           jz   okalign4      "\
"           mov  [edi], al     "\
"           inc  edi           "\
"           dec  ebx           "\
"           jne  lpalign4      "\
"           jmp  fmemsetb      "\
"okalign4:  mov  ecx, ebx      "\
"           shr  ecx, 2        "\
"           repne stosd        "\
"           mov  cl, bl        "\
"           and  cl, 3         "\
"           repne stosb        "\
"fmemsetb:                     "\
            modify [eax ebx ecx edi]\
            parm [edi] [eax] [ecx];

// ***********************Created: 04/04/96 19h20mn***************************
// Fill a array with a long
// In:  dst -> array
//      c   -> long used to  fill (decl. as UL for optimisation)
//      nb  -> number of byte to put in the array
// *********************Last change: 25/10/97 18h07mn*************************
void memsetl(void *dst, UL c, UL nb);
//                EDI   EAX   ECX
#pragma aux memsetl =          \
"           mov  ebx, eax      "\
"lpalign4:  test edi, 3        "\
"           jz   okalign4      "\
"           mov  [edi], al     "\
"           inc  edi           "\
"           ror  eax, 8        "\
"           dec  ecx           "\
"           jne  lpalign4      "\
"           jmp  fmemsetl      "\
"okalign4:  mov  ebx, ecx      "\
"           shr  ecx, 2        "\
"           repne stosd        "\
"           mov  ecx, ebx      "\
"           and  cl, 3         "\
"           jz   fmemsetl      "\
"lpfmemsetl:mov  [edi], al     "\
"           inc  edi           "\
"           ror  eax, 8        "\
"           dec  ecx           "\
"           jnz  lpfmemsetl    "\
"fmemsetl:                     "\
            modify [eax ebx ecx edi]\
            parm [edi] [eax] [ecx];
// Fill memory with a 24 bytes filler.
// ! len must a multiple of 3. Memory is filled til the first multiple of 3>=len
// *********************Last change: 25/10/97 18h08mn*************************
void memset24( void *dst, UL filler, UL len );
//                  EDI      EAX        ECX
#pragma aux memset24 = \
"            or  ecx, ecx                     "\
"            jz ffill                         "\
"            mov ebx, eax                     "\
"            shr eax, 8                       "\
"            lea edx, [esi+eax]               "\
"lpfill:     mov [edi], bl                    "\
"            mov [edi+1], al                  "\
"            mov [edi+2], ah                  "\
"            add edi, 3                       "\
"            cmp edi, edx                     "\
"            jl  lpfill                       "\
"ffill:                                       "\
             modify [ebx edx edi] \
             parm [edi] [eax] [ecx];

// ***********************Created: 04/04/96 19h32mn***************************
// Copy a buffer to another buffer
// In:  src -> source buffer
//      dst -> destination buffer
//      sz  -> size a the buffer
// *********************Last change: 04/04/96 23h28mn*************************
// void memcpyf(void *dst, void *src, UL sz);
//                    EDI        ESI    ECX
#pragma aux memcpyf =                                         \
"           mov ebx, ecx                                      "\
"           shr ecx, 2                                        "\
"           repne movsd                                       "\
"           mov ecx, ebx                                      "\
"           and ecx, 3                                        "\
"           repne movsb                                       "\
            modify [ecx esi edi]\
            parm [edi] [esi] [ecx];

// Multiply two number * 2^16
// (x <<16) * (y <<16) => (x*y) <<16
// *********************Last change: 25/10/97 19h33mn*************************
SL mul16( SL x, SL y );
#pragma aux mul16 = \
"     imul edx                                "\
"     shrd eax,edx,16                         "\
             modify [edx] \
             parm [eax] [edx] \
             value [eax];

// inlines:
// ###########################################################################
inline void memset8( void *dst, UB filler, SL len )
{
  memset( dst, filler, len );
}

inline void memset16( void *dst, UW filler, SL len )
{
  memsetw( dst, filler, len );
}

inline void memset32( void *dst, UL filler, SL len )
{
  memsetl( dst, filler, len );
}


// #######################Created: 04/04/96 19h16mn###########################
// Prototypes:
// #####################Last change: 04/04/96 19h16mn#########################
extern void load_es();
extern void memsetw(void *dst, UW c, UL nb);
extern void memsetb(void *dst, UL c, UL nb);
extern void memcpyf(void *dst, void *src, UL sz);


#endif

#endif


// ############################ EOF ASMINLIN.H ###############################
// ############################ EOF ASMINLIN.H ###############################
// ############################ EOF ASMINLIN.H ###############################

