// ###########################################################################
// File: EArray.h
// (c)Copyright 03/1999, Gaia Creation, Baptiste Lepilleur
// ###########################################################################

#if !defined(AFX_EARRAYT_H__B5167F21_C8C5_11D2_BD2F_0040053AD648__INCLUDED_)
#define AFX_EARRAYT_H__B5167F21_C8C5_11D2_BD2F_0040053AD648__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000


/* Notes:
 * Should add  void remove( Item & ) and void take( Item &).
 */


/* Array type list :
EDECLARE_ARRAY( ESimpleAllocatorBinT, EBinArrayT );
EDECLARE_ARRAY( ESimpleAllocatorObjT, EObjArrayT );
EDECLARE_ARRAY( ESimpleAllocatorPtrT, EPtrArrayT );
EDECLARE_ARRAY( EDynAllocatorBinT, EBinDynArrayT );
EDECLARE_ARRAY( EDynAllocatorObjT, EObjDynArrayT );
EDECLARE_ARRAY( EDynAllocatorPtrT, EPtrDynArrayT );
 */

/* History:
 * 20/02/1999: - Use code of the previous EArray class for this generic template.
 *             Incompatibile change to be beware of:
 *               - removes find(), contains() ==() and !=() methods which implied 
 *                 the need of an == operator.
 *                 Those method will be provides which a subclass of this template,
 *                 with many other methods (such as sorting). 
 *
 *               - remove() default parameter is now 1, meaning only one element is
 *                 removed instead of the previous behavior which removes all 
 *                 elements until the end of the array.
 *
 *               - removes the const TElm *() cast operator. Use the data() method
 *                 instead.
 *
 *               - takeXXX() method.
 * 21/02/1999: - BugFix: slice() for Ptr array -> ownership pb fixed !
 *             - Adds : setGranularity() & granularity().
 * 03/03/1999: - Adds : first() & last().
 * 20/03/1999: - Adds : TElm take( SL nIndex )
 *                      void take( SL nIndex, TElm &elm )
 *                      TElm takeLast( SL nIndex )
 *                      void takeLast( SL nIndex, TElm &elm )
 * 21/03/1999: - Adds SL find( const TElm &elm,
 *                             SL nStartIndex =0 ) const
 *                    SL findRev( const TElm &elm,
 *                                SL nStartIndex =-1 ) const
 *                    Using thoses method implied that the element as a == operator.
 *             - Changes prototype of takeLast() & take() so they can use 
 *               default parameters.
 * 30/05/2000: - Adds void remove( const TElm &elm)
 *                    bool take( const TElm &elm ) 
 */


/* Test: [See project EToolLibTest].
 
 EBinArrayT & EBinDynArrayT:
 ***************************
 [OK] EArrayT()
 [OK] EArrayT( SL nInitialSize )
 [OK] EArrayT( const EArrayType &array )
 [OK] ~EArrayT()
 [OK] EArrayT<TElm,EAllocator>& operator =( const EArrayType &array )
 [OK] TElm& operator []( SL nIndex )
 [OK] const TElm& operator []( SL nIndex ) const
 [OK] const TElm& at( SL nIndex ) const
 [OK] TElm& at( SL nIndex )
 [  ] TElm *data()
 [  ] const TElm *data() const
 [OK] const TElm &first() const
 [OK] const TElm &last() const
 [OK] TElm &first()
 [OK] TElm &last()
 [OK] SL count() const
 [OK] SL maxCount() const
 [OK] bool isEmpty() const
 [OK] void resize( SL nNewSize )
 [OK] void reset()
 [OK] void setGranularity( SL nGranularity )
 [OK] void granularity( SL nGranularity )
 [OK] EArrayType slice( SL nIndex, 
                        SL nSize =-1 ) const
 [OK] EArrayType& duplicate( const EArrayT<TElm,EAllocator>& a )
 [OK] void move( SL nIndex, 
                 SL nLen, 
                 SL nIndexDst )
 [OK] void remove( SL nIndex, 
                   SL nLen =1 )
 [OK] void insert( SL nIndex, 
                   const TElm& value )
 [OK] void insert( SL nIndex, 
                   const EArrayT<TElm,EAllocator>& array )
 [OK] void append( const TElm& value )
 [OK] void append( const EArrayT<TElm,EAllocator>& array )
 [  ] TElm take( SL nIndex ) 
 [  ] void take( SL nIndex, TElm &elm ) 
 [  ] TElm takeLast( SL nIndex ) 
 [  ] void takeLast( SL nIndex, TElm &elm ) 
 [  ] SL find( const TElm &elm,
 [  ]          SL nStartIndex =0 ) const
 [  ] SL findRev( const TElm &elm,
 [  ]             SL nStartIndex =-1 ) const

 EObjArrayT & EObjDynArrayT:
 ***************************
 [OK] EArrayT()
 [OK] EArrayT( SL nInitialSize )
 [OK] EArrayT( const EArrayType &array )
 [OK] ~EArrayT()
 [OK] EArrayT<TElm,EAllocator>& operator =( const EArrayType &array )
 [OK] TElm& operator []( SL nIndex )
 [OK] const TElm& operator []( SL nIndex ) const
 [OK] const TElm& at( SL nIndex ) const
 [OK] TElm& at( SL nIndex )
 [  ] TElm *data()
 [  ] const TElm *data() const
 [OK] SL count() const
 [OK] SL maxCount() const
 [OK] bool isEmpty() const
 [OK] void resize( SL nNewSize )
 [OK] void reset()
 [OK] EArrayType slice( SL nIndex, 
                        SL nSize =-1 ) const
 [OK] EArrayType& duplicate( const EArrayT<TElm,EAllocator>& a )
 [OK] void move( SL nIndex, 
                 SL nLen, 
                 SL nIndexDst )
 [OK] void remove( SL nIndex, 
                   SL nLen =1 )
 [OK] void insert( SL nIndex, 
                   const TElm& value )
 [OK] void insert( SL nIndex, 
                   const EArrayT<TElm,EAllocator>& array )
 [OK] void append( const TElm& value )
 [OK] void append( const EArrayT<TElm,EAllocator>& array )

 EPtrArrayT & EPtrDynArrayT:
 ***************************
 [OK] EArrayT()
 [OK] EArrayT( SL nInitialSize )
 [OK] EArrayT( const EArrayType &array )
 [OK] ~EArrayT()
 [OK] EArrayT<TElm,EAllocator>& operator =( const EArrayType &array )
 [OK] TElm& operator []( SL nIndex )
 [OK] const TElm& operator []( SL nIndex ) const
 [OK] const TElm& at( SL nIndex ) const
 [OK] TElm& at( SL nIndex )
 [  ] TElm *data()
 [  ] const TElm *data() const
 [OK] SL count() const
 [OK] SL maxCount() const
 [OK] bool isEmpty() const
 [OK] void resize( SL nNewSize )
 [OK] void reset()
 [OK] EArrayType slice( SL nIndex, 
                        SL nSize =-1 ) const
 [OK] EArrayType& duplicate( const EArrayT<TElm,EAllocator>& a )
 [OK] void move( SL nIndex, 
                 SL nLen, 
                 SL nIndexDst )
 [OK] void remove( SL nIndex, 
                   SL nLen =1 )
 [OK] void insert( SL nIndex, 
                   const TElm& value )
 [OK] void insert( SL nIndex, 
                   const EArrayT<TElm,EAllocator>& array )
 [OK] void append( const TElm& value )
 [OK] void append( const EArrayT<TElm,EAllocator>& array )
 */




// ###########################################################################

template<class TElm, class EAllocator>
class EArrayIteratorT;

#include "EAllocators.h"
#include "EBaseArrayT.h"
 
 /*! Macro used to declare an array template class for a given allocator type.
 * @param ClassAllocator Name of the allocator template class.
 * @param ClassName Name of the template class to declare.
 */
#define EDECLARE_ARRAY( ClassAllocator, ClassName )                            \
    template<class TElm>                                                       \
    class ClassName : public EArrayT< TElm, ClassAllocator<TElm> >             \
    {                                                                          \
    public:                                                                    \
      ClassName() {}                                                           \
                                                                               \
      ClassName( SL nInitialSize ) :                                           \
          EArrayT< TElm, ClassAllocator<TElm> >( nInitialSize ) {}             \
                                                                               \
      ClassName( const ClassName &array ) :                                    \
          EArrayT< TElm, ClassAllocator<TElm> >( array ) {}                    \
                                                                               \
      ~ClassName() {}                                                          \
                                                                               \
      ClassName &operator =( const EArrayT< TElm, ClassAllocator<TElm> > &array ) \
      {                                                                        \
        EArrayT< TElm, ClassAllocator<TElm> >::operator =( array );            \
        return *this;                                                          \
      }                                                                        \
                                                                               \
      TElm &operator[]( SL nIndex )                                            \
      {                                                                        \
        return at( nIndex );                                                   \
      }                                                                        \
                                                                               \
      const TElm &operator[]( SL nIndex ) const                                \
      {                                                                        \
        return at( nIndex );                                                   \
      }                                                                        \
    };

 
 /*! 
 * \brief Template class that provides arrays.
 * 
 * The template definition is as follow:
 * \code
 * template<class TElm,EAllocator>
 * class EArrayT;
 * \endcode
 *
 * The only requirement on stored element are that they supports the following:
 * - copy operator
 * - default constructor and destructor for C++ object.
 *
 * For array of pointer:
 * - Object must be allocated using \c new (if ownership is \c true).
 * - Object will be freed using \c delete (if ownership is \c true).
 * - When a array is copied from another one, its ownership is set to \c false.
 *
 *  @param TElm Type of items stored in the arry.
 *  @param EAllocator Allocator class used to manage the array.
 */
template<class TElm, class EAllocator>
class EArrayT : public EBaseArrayT<TElm>
{
public:
  typedef EArrayIteratorT<TElm,EAllocator> EIterator;
  typedef EArrayIteratorT<const TElm,EAllocator> EIteratorConst;

  /*! Alias for this type of array.
   */
  typedef EArrayT<TElm,EAllocator> EArrayType;

  /*! Default constructor
   *
   * Constructs an empty array.
   */
  EArrayT();

  /*!
   * Constructs an array with a size large enough to store \a size element.
   * @param size Initial size of the array
   */
  EArrayT( SL nInitialSize );

  /*! Copy constructor.
   * Constructs a copy of the array \a array. 
   * each element of the array.
   * @param a array to copy.
   */
  EArrayT( const EArrayType &array );

  /*! Destructor
   */
  ~EArrayT();

  /*! Copy operator.
    * Copy the array \a array.
    * @param a array to copy.
    */
  EArrayT<TElm,EAllocator>& operator =( const EArrayType &array );




  /*! Returns a reference to the element at position \a nIndex in the array.
   * @param nIndex position of the referenced element. 0 is the first element
   *              of the array.
   */
  TElm& operator []( SL nIndex );

  /*! Returns a reference to the element at position \a nIndex in the array.
   * @param nIndex position of the referenced element. 0 is the first element
   *              of the array.
   */
  const TElm& operator []( SL nIndex ) const;

  /*! Returns a reference to the element at position \a nIndex in the array.
   * @param nIndex position of the referenced element. 0 is the first element
   *              of the array.
   */
  const TElm& at( SL nIndex ) const;

  /*! Returns a reference to the element at position \a nIndex in the array.
   * @param nIndex position of the referenced element. 0 is the first element
   *              of the array.
   */
  TElm& at( SL nIndex );

  /*! Get a pointer on the first element of the array.
   * The returned pointer is the beginning of the array. As it
   * is stored like a standard C array you can read or write the array this way.
   *
   * Beware that data() might returns \c NULL if the array contains 0 element.
   * 
   * This can be used to interface with function such as \c qsort.
   * @return Returns a pointer on the first element of the array.
   */
  TElm *data();

  /*! Get a pointer on the first element of the array.
   * The returned pointer is the beginning of the array. As it
   * is stored like a standard C array you can read or write the array this way.
   *
   * Beware that data() might returns \c NULL if the array contains 0 element.
   * 
   * This can be used to interface with function such as \c qsort.
   * @return Returns a pointer on the first element of the array.
   */
  const TElm *data() const;

  /*! Gets the first element of the array.
   * @return The first element of the array.
   */
  const TElm &first() const;

  /*! Gets the first element of the array.
   * @return The first element of the array.
   */
  TElm &first();

  /*! Gets the last element of the array.
   * @return The last element of the array.
   */
  const TElm &last() const;

  /*! Gets the last element of the array.
   * @return The last element of the array.
   */
  TElm &last();




  /*! Returns the number of elements in the array.
   * @return Number of elements in the array.
   */
  SL count() const;

  /*! Returns the maximum number of elements for the array.
   * This is the number of elements that can be stored in the array
   * without any reallocation.
   *
   * If the array use a simple allocator then maxCount() will always returns
   * then same value as count(). If the array use a dynamic allocator then maxCount()
   * will returns a value greater or equal to count() depending on the granularity 
   * value.
   *
   * @return Number of elements that can be stored without reallocation.
   */
  SL maxCount() const;

  /*! Tests if the array is empty.
   * The array is empty if count() returns 0.
   * @return \c true if the array is empty, \c false otherwise.
   */
  bool isEmpty() const;

  /*! Resizes the array.
   * Shrinks or expands the array so it can hold \a size elements. The new
   * elements are unitialised. If a size of 0 is given then the array becomes
   * empty.
   * @param nNewSize New size of the array. Must be >= 0.
   */
  void resize( SL nNewSize );

  /*! Remove all elements from the array.
   * Resize the array to a size of 0.
   */
  void reset();

  /*! Set granularity.
   * @param nGranularity New granularity. Must be greater than 0.
   * \warning Must be used only with dynamic arrray.
   */
  void setGranularity( SL nGranularity );

  /*! Get the granularity.
   * @return Granularity.
   * \warning Must be used only with dynamic arrray.
   */
  SL granularity() const;
 

  /*! Set the ownership flag.
   * @param bOwnObject If \a bOwnObject is \c true then the allocator owns the
   *                   object. This means they are destroyed when destruct() is called.
   *                   If \a bOwnObject is \c false then object are not destroyed.
   */
  void setOwnership( bool bOwnObject = true );

  /*! Tests if the allocator owns the object.
   */
  bool ownership() const;



  /*! Duplicates a slice of the array.
   * The returned array is a copy of the elements of this array beginning
   * at the position \a nIndex and of length \a nSize.
   *
   * The first element of the array is at position 0.
   *
   * If \a nSize is negative then the copy of elements stop at position
   * count()+nSize. This means that if \a nSize = -1 then the slice extends
   * until the end of this array. If \a nSize = -2 then the slice extends
   * until the element preceding the last one...
   *
   * The slice ownership flag is always set to \c false.
   *
   * @param nIndex Position of the first element to copy. 0 is the position
   *               of the first element
   * @param nSize Length of the slice.
   * @return An array that contains the slice.
   */
  EArrayType slice( SL nIndex, 
                    SL nSize =-1 ) const;

  /*! Fills the array with a given element.
   * Fills the array with element \a filler. Resize the array before filling
   * if \a len if a positive number. The method used to copy the element
   * depends on the binary mode.
   * constructor.
   * @param filler element used to fill the array.
   * @param len resize the array if positive (>=0).
   * @see setBinaryMode
   */
//  void fill( const TElm &filler, 
//             SL nLen =-1 );

  /*! Duplicate an array.
   * Copy the array \a array to this array.
   * @param array Array to copy.
   * @return Reference on this array.
   */
  EArrayType& duplicate( const EArrayT<TElm,EAllocator>& a );

  /*! Duplicate an array.
   * Copy \a nSize elements of the array \a array.
   * @param array Array to copy. May be NULL if nSize is 0.
   * @param nSize Number of elements to copy
   * @return Reference on this array.
   */
  EArrayType& duplicate( const TElm *array, 
                         SL nSize );

  /*! Copy a slice of the array at another position.
   * Copies \a nLen elements of the array starting at position \a nIndex
   * to position \a nIndexDst.
   * If \a nLen is negative then element are copied from position \a nIndex to
   * position count()+nLen. Therefore a value of -1 for \a nLen means that elements
   * are copied until the end of the array.
   * @param nIndex Zero based index of the first element to copy.
   * @param nIndexDst Zero based index where the first element is copied to.
   * @param nLen Numbers of elements to copy. if \a nLen is less than 0 then
   *             element are copied until the position count() + \a nLen is reached.
   *             count() + \a nLen must always be greater or equal to \a nIndex.
   */
 void move( SL nIndex, 
            SL nLen, 
            SL nIndexDst );

 /*! Removes somes elements from the array.
  * Removes elements from the array and resizes the array to the
  * right size.
  * If \a len is negative then element are removes from position \a index to
  * position count()+len. The default value of -1 means that elements are
  * removed from position \a index to the end of the array. That is
  * equivalent to truncate the array at position \a index.
  * @param index index of the first element to delete.
  * @param len number of elements of delete.
  */
 void remove( SL nIndex, 
              SL nLen =1 );

 /*! 
  * Removes the first occurence of the specified item from the array.
  * @param value Item to remove.
  */
 void remove( const TElm &value );

 /*! Inserts a element in the array.
  * Inserts the element \a value in the array at position \a nIndex. 
  * If \a nIndex is greater than the length of the array then the array is extended. 
  * The extended part of the array is left unitialised except for the inserted element.
  * @param nIndex Zero based index where the element.
  * @param value Element to insert.
  */
 void insert( SL nIndex, 
              const TElm& value );

 /*! Inserts another array in the array.
  * Inserts the array \a array at position \a nIndex.
  * If \a nIndex is greater than the length of the array then the array is extended. 
  * The extended part of the array is left unitialised except for the inserted elements.
  * @param nIndex Zero based index where the array is inserted.
  * @param array Array to insert.
  */
 void insert( SL nIndex, 
              const EArrayT<TElm,EAllocator>& array );

 /*! Append an element at the end of the array.
  * Increases the size of the array by one and insert the element \a value at the end.
  * @param value Element to append.
  */
 void append( const TElm& value );

 /*! Append an array at the end of the array.
  * Append an array at the end of the array.
  * @param array Array to append at the end.
  */
 void append( const EArrayT<TElm,EAllocator>& array );

 /*! Takes one element from the array.
  *
  * The element is removed from the array and returned.
  *
  * @param nIndex Zero based index of the element to take.
  * @return Taken element.
  */
 TElm take( SL nIndex =0 );

 /*! Takes one element from the array.
  *
  * The element is removed from the array and returned.
  *
  * @param elm On return, taken element.
  * @param nIndex Zero based index of the element to take.
  */
 void take( TElm &elm,
            SL nIndex =0 );

 /*!
  * Takes the specified element from the array.
  * Removes the specified element from the array without destroying it.
  * @param value Element to take.
  * @return \c true if the element has been taken.
  */
 bool take( const TElm &value );

 /*! Takes one element from the end of the array.
  *
  * The element is removed from the array and returned.
  *
  * @param nIndex Length based index of the element to take. 0 is the last element,
  *               1 is the element before the last one...
  *               Formula to compute the zero based index is : 
  *               index = length() -1 - \a nIndex.
  * @return Taken element.
  */
 TElm takeLast( SL nIndex = 0);

 /*! Takes one element from the end of the array.
  *
  * The element is removed from the array and returned.
  *
  * @param elm On return, taken element.
  * @param nIndex Length based index of the element to take. 0 is the last element,
  *               1 is the element before the last one...
  *               Formula to compute the zero based index is : 
  *               index = length() -1 - \a nIndex.
  */
 void takeLast( TElm &elm,
                SL nIndex =0 );


  /*! Finds an element.
   * 
   * The search goes from the given position to the end of the array.
   *
   * @param elm Element to find in the array.
   * @param nStartIndex Zero based index the search begin at.
   *                    If less than 0 then the starting index is 
   *                    length() + \a nStartIndex. Therefore if \a nStartIndex is -1
   *                    the search will begin at the last element of the array.
   * @return If the element if found the zero based of the first found occurence 
   *         of \a elm is returned, otherwise -1 is returned.
   */
  SL find( const TElm &elm,
           SL nStartIndex =0 ) const;

  /*! Finds an element starting from the end of the array.
   * 
   * The search goes from the given position included to the beginning of the array.
   *
   * @param elm Element to find in the array.
   * @param nStartIndex Zero based index the search begin at.
   *                    If less than 0 then the starting index is 
   *                    length() + \a nStartIndex. Therefore if \a nStartIndex is -1
   *                    the search will begin at the last element of the array.
   * @return If the element if found the zero based of the first found occurence 
   *         of \a elm is returned, otherwise -1 is returned.
   */
  SL findRev( const TElm &elm,
              SL nStartIndex =-1 ) const;


private:
  EAllocator _allocator;
};


EDECLARE_ARRAY( ESimpleAllocatorBinT, EBinArrayT );
EDECLARE_ARRAY( ESimpleAllocatorObjT, EObjArrayT );
EDECLARE_ARRAY( ESimpleAllocatorPtrT, EPtrArrayT );
EDECLARE_ARRAY( EDynAllocatorBinT, EBinDynArrayT );
EDECLARE_ARRAY( EDynAllocatorObjT, EObjDynArrayT );
EDECLARE_ARRAY( EDynAllocatorPtrT, EPtrDynArrayT );
//EDECLARE_ARRAY( EDynAllocatorBinT, EBinArrayT );
//EDECLARE_ARRAY( EDynAllocatorObjT, EObjArrayT );
//EDECLARE_ARRAY( EDynAllocatorPtrT, EPtrArrayT );

#include "EArrayIterator.h"


// Implementation:
// #####################Last change: 21/08/97 22h40mn#########################

template<class TElm, class EAllocator>
inline 
EArrayT<TElm,EAllocator>::EArrayT()
{
}


template<class TElm, class EAllocator>
EArrayT<TElm,EAllocator>::EArrayT( SL nSize )
{
  _allocator.resize( nSize );
}


template<class TElm, class EAllocator>
EArrayT<TElm,EAllocator>::EArrayT( const EArrayType &array )
{
  _allocator.copy( array._allocator );
}


template<class TElm, class EAllocator>
EArrayT<TElm,EAllocator>::~EArrayT()
{
}


template<class TElm, class EAllocator>
EArrayT<TElm,EAllocator>& EArrayT<TElm,EAllocator>::operator =( const EArrayT<TElm,EAllocator> &array )
{
  _allocator.copy( array._allocator );
  return *this;
}


template<class TElm, class EAllocator>
inline TElm& 
EArrayT<TElm,EAllocator>::operator []( SL nIndex )
{
  return _allocator.at( nIndex );
}


template<class TElm, class EAllocator>
inline const TElm& 
EArrayT<TElm,EAllocator>::operator []( SL nIndex ) const
{
  return _allocator.at( nIndex );
}


template<class TElm, class EAllocator>
inline TElm& 
EArrayT<TElm,EAllocator>::at( SL nIndex )
{
  return _allocator.at( nIndex );
}


template<class TElm, class EAllocator>
inline const TElm& 
EArrayT<TElm,EAllocator>::at( SL nIndex ) const
{
  return _allocator.at( nIndex );
}


template<class TElm, class EAllocator>
inline TElm *
EArrayT<TElm,EAllocator>::data()
{
  return &_allocator.at( 0 );
}


template<class TElm, class EAllocator>
inline const TElm *
EArrayT<TElm,EAllocator>::data() const
{
  return &allocator.at( 0 );
}


template<class TElm, class EAllocator>
inline const TElm &
EArrayT<TElm,EAllocator>::first() const
{
  return at( 0 );
}


template<class TElm, class EAllocator>
inline TElm &
EArrayT<TElm,EAllocator>::first()
{
  return at( 0 );
}

template<class TElm, class EAllocator>
inline const TElm &
EArrayT<TElm,EAllocator>::last() const
{
  return at( count() -1 );
}

template<class TElm, class EAllocator>
inline TElm &
EArrayT<TElm,EAllocator>::last()
{
  return at( count() -1 );
}




template<class TElm, class EAllocator>
inline SL 
EArrayT<TElm,EAllocator>::count() const
{
  return _allocator.count();
}


template<class TElm, class EAllocator>
inline SL 
EArrayT<TElm,EAllocator>::maxCount() const
{
  return _allocator.maxCount();
}


template<class TElm, class EAllocator>
inline bool 
EArrayT<TElm,EAllocator>::isEmpty() const
{
  return count() == 0;
}


template<class TElm, class EAllocator>
inline void 
EArrayT<TElm,EAllocator>::resize( SL nNewSize )
{
  _allocator.resize( nNewSize );
}


template<class TElm, class EAllocator>
inline void 
EArrayT<TElm,EAllocator>::reset()
{
  _allocator.resize( 0 );
}


template<class TElm, class EAllocator>
inline void 
EArrayT<TElm,EAllocator>::setGranularity( SL nGranularity )
{
  _allocator.setGranularity( nGranularity );
}


template<class TElm, class EAllocator>
inline SL 
EArrayT<TElm,EAllocator>::granularity() const
{
  return _allocator.granularity();
}



template<class TElm, class EAllocator>
EArrayT<TElm,EAllocator> 
EArrayT<TElm,EAllocator>::slice( SL nIndex, SL nLen ) const
{
  EASSERT( nIndex >= 0 );
  SL nEndPos = nLen >= 0 ? nIndex + nLen : emax( nIndex, 
                                                 count() + nLen +1 );
  SL nSize = emax( nEndPos -nIndex, 0 );
  EArrayT<TElm,EAllocator> array( nSize );
  array.setOwnership( false );
  _allocator.copyTo( nIndex, nSize,
                     0,
                     array._allocator );
  return array;
}


template<class TElm, class EAllocator>
EArrayT<TElm,EAllocator>& 
EArrayT<TElm,EAllocator>::duplicate( const EArrayT<TElm,EAllocator>& array )
{
  SL nCount = array._allocator.count();
  _allocator.resize( nCount );
  array._allocator.copyTo( 0, nCount,
                           0,
                           _allocator );

  return *this;
}


template<class TElm, class EAllocator>
EArrayT<TElm,EAllocator>& 
EArrayT<TElm,EAllocator>::duplicate( const TElm *array, 
                                   SL nSize )
{
  _allocator.resize( nSize );
  _allocator.copyFrom( array, nSize,
                       0 );

  return *this;
}


template<class TElm, class EAllocator>
void 
EArrayT<TElm,EAllocator>::move( SL nIndex, 
                              SL nLen, 
                              SL nIndexDst )
{
  EASSERT( nIndex >= 0 );
  EASSERT( nIndexDst >= 0 );
  SL nEndPos = nLen >= 0 ? nIndex + nLen : emax( nIndex, 
                                                 count() + nLen +1 );
  SL nSize = ebound( nEndPos -nIndex, 0, count() -nIndexDst );

  if ( !nSize )
    return;

  _allocator.copyToThis( nIndex, nSize,
                         nIndexDst );
}

template<class TElm, class EAllocator>
void 
EArrayT<TElm,EAllocator>::remove( SL nIndex, 
                                  SL nLen )
{
  EASSERT( nIndex >= 0 );
  SL nEndPos = nLen >= 0 ? nIndex + nLen : emax( nIndex, 
                                                 count() + nLen +1 );
  SL nSize = emax( nEndPos -nIndex, 0 );

  _allocator.copyToThis( nEndPos, count() - nEndPos, nIndex );
  _allocator.resize( count() -nSize );
}


template<class TElm, class EAllocator>
void 
EArrayT<TElm,EAllocator>::remove( const TElm &value )
{
  int nIdx = find( value, 0 );
  if ( nIdx < 0 )
    return;
  remove( nIdx, 1 );
}


template<class TElm, class EAllocator>
void 
EArrayT<TElm,EAllocator>::insert( SL nIndex, 
                                  const TElm& value )
{
  EASSERT( nIndex >= 0 );

  if ( nIndex >= count() )
    _allocator.resize( nIndex +1 );
  else
  {
    _allocator.resize( count() +1 );
    move( nIndex, -1, nIndex+1 );
  }

  at( nIndex ) = value;
}


template<class TElm, class EAllocator>
void 
EArrayT<TElm,EAllocator>::insert( SL nIndex, 
                                const EArrayT<TElm,EAllocator>& array )
{
  EASSERT( nIndex >= 0 );

  if ( nIndex >= count() )
    resize( nIndex +array.count() );
  else
  {
    resize( count() + array.count() );
    move( nIndex, -1, nIndex +array.count() );
  }

  array._allocator.copyTo( 0, array.count(),
                           nIndex,
                           _allocator );
}


template<class TElm, class EAllocator>
inline void 
EArrayT<TElm,EAllocator>::append( const TElm& value )
{
  SL nCount = count();
  _allocator.resize( nCount +1 );
  at( nCount ) = value;
}


template<class TElm, class EAllocator>
inline void 
EArrayT<TElm,EAllocator>::append( const EArrayT<TElm,EAllocator>& array )
{
  SL nIndexDst = count();
  SL nCount = array.count();
  _allocator.resize( nIndexDst + nCount );
  array._allocator.copyTo( 0, nCount,
                           nIndexDst,
                           _allocator );
}


template<class TElm, class EAllocator>
inline void 
EArrayT<TElm,EAllocator>::setOwnership( bool bOwnObject )
{
  _allocator.setOwnership( bOwnObject );
}


template<class TElm, class EAllocator>
bool 
EArrayT<TElm,EAllocator>::ownership() const
{
  return _allocator.ownership();
}


template<class TElm, class EAllocator>
inline TElm 
EArrayT<TElm,EAllocator>::take( SL nIndex )
{
  TElm elm;
  take( elm, nIndex );
  return elm;
}


template<class TElm, class EAllocator>
bool 
EArrayT<TElm,EAllocator>::take( const TElm &value )
{
  int nIdx = find( value, 0 );
  if ( nIdx < 0 )
    return false;
  SL nLength = count() -1;
  bool bOwnership = ownership();
  setOwnership( false );
  if ( nIdx == nLength )
    resize( nLength );
  else
    move( nIdx +1, -1, nIdx );
  setOwnership( bOwnership );
  return true;
}


template<class TElm, class EAllocator>
void 
EArrayT<TElm,EAllocator>::take( TElm &elm,
                                SL nIndex )
{
  elm = at( nIndex );
  SL nLength = count() -1;
  bool bOwnership = ownership();
  setOwnership( false );
  if ( nIndex == nLength )
    resize( nLength );
  else
    move( nIndex +1, -1, nIndex );
  setOwnership( bOwnership );
}


template<class TElm, class EAllocator>
inline TElm 
EArrayT<TElm,EAllocator>::takeLast( SL nIndex )
{
  EASSERT( nIndex >= 0 );
  return take( count() -1 - nIndex );
}


template<class TElm, class EAllocator>
inline void 
EArrayT<TElm,EAllocator>::takeLast( TElm &elm,
                                    SL nIndex )
{
  EASSERT( nIndex >= 0 );
  take( elm,
        count() -1 - nIndex );
}


template<class TElm, class EAllocator>
SL 
EArrayT<TElm,EAllocator>::find( const TElm &elm,
                                SL nStartIndex ) const
{
  SL nLength = count();

  if ( !nLength )     // array is empty !
    return -1;

  if ( nStartIndex < 0 )
    nStartIndex += nLength;

  EASSERT( nStartIndex >=0  &&  nStartIndex <= nLength );

  for ( ; nStartIndex < nLength; nStartIndex++ )
  {
    if ( at( nStartIndex ) == elm )     // found !
      return nStartIndex;
  }

  return -1;
}

template<class TElm, class EAllocator>
SL 
EArrayT<TElm,EAllocator>::findRev( const TElm &elm,
                                   SL nStartIndex ) const
{
  SL nLength = count();

  if ( !nLength )     // array is empty !
    return -1;

  if ( nStartIndex < 0 )
    nStartIndex += nLength;

  EASSERT( nStartIndex >=0  &&  nStartIndex < nLength );

  for ( ; nStartIndex >= 0; nStartIndex-- )
  {
    if ( at( nStartIndex ) == elm )     // found !
      return nStartIndex;
  }

  return -1;
}


#endif // !defined(AFX_EARRAYT_H__B5167F21_C8C5_11D2_BD2F_0040053AD648__INCLUDED_)
