// ###########################################################################
// File: ECallback9T.h
// (c)Copyright 03/1999, Gaia Creation, Baptiste Lepilleur
// ###########################################################################
#if !defined(AFX_ECALLBACK9T_H__B78AA269_D476_11D2_BD55_0040053AD648__INCLUDED_)
#define AFX_ECALLBACK9T_H__B78AA269_D476_11D2_BD55_0040053AD648__INCLUDED_

// This "code template" is to be used with the following macro to generate
// the code for the ECallbacks templates.

/*
Sub Template()
'DESCRIPTION: Smart replace
' use all couples #XXXXX=YYYYY to replace #{XXXX} occurences by YYYY

	if ( Not ActiveDocument.Type = "Text" ) Then
	  exit sub
	end if
	Dim Doc 
	Set Doc = ActiveDocument
	Dim Sel
	Set Sel = Doc.Selection
	Dim TxtReplace
	Dim TxtReplaceBy

	nLastLine = -1
	Sel.StartOfDocument
	do
	  Sel.FindText "^#\:i=", dsMatchForward + dsMatchRegExp
	  nFindLine = Sel.CurrentLine
	  if ( nFindLine <= nLastLine ) then
	    exit do
	  end if
	  nLastLine = Sel.CurrentLine
	  Sel.SelectLine
	  TxtReplace = Sel.Text
	  nPosEqual = inStr( TxtReplace, "=" ) -1
	  TxtReplaceBy = rtrim(mid( TxtReplace, nPosEqual+2))
	  
	  '-2 to remove trailing chr(13) chr(10)
	  TxtReplaceBy = left(TxtReplaceBy,len(TxtReplaceBy)-2)	
	  TxtReplace = "#{" & mid( TxtReplace, 2, nPosEqual -1 ) & "}"
	  Doc.ReplaceText TxtReplace, TxtReplaceBy, dsMatchCase 
	  Sel.GoToLine nFindLine+1
	loop

End Sub
*/



/*
// ECallback9T

#ECallback=ECallback9T
#PARAM_CALL=TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6,TP7 p7,TP8 p8,TP9 p9
#PARAM_CALL_SEP=, #{PARAM_CALL}
#PARAM_DECL=TP1,TP2,TP3,TP4,TP5,TP6,TP7,TP8,TP9
#PARAM_DECL_FN=TP1Fn,TP2Fn,TP3Fn,TP4Fn,TP5Fn,TP6Fn,TP7Fn,TP8Fn,TP9Fn
#CALL_LIST=p1,p2,p3,p4,p5,p6,p7,p8,p9
#CALL_LIST_SEP=, #{CALL_LIST}
#SUFFIX=9T
#TEMPLATE_PARAM_RET=class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7,class TP8,class TP9
#TEMPLATE_PARAM=,#{TEMPLATE_PARAM_RET}
#TEMPLATE_PARAM_RET_SEP=,#{TEMPLATE_PARAM_RET}
#TEMPLATE_PARAM_RET_SEP_ARG=,#{PARAM_DECL}
#TEMPLATE_PARAM_CB=<#{TEMPLATE_PARAM_RET}>
#TEMPLATE_PARAM_CB_ARG=<#{PARAM_DECL}>
#TEMPLATE_CB_DECL=template#{TEMPLATE_PARAM_CB}
#TEMPLATE_PARAM_FN=,class TP1Fn,class TP2Fn,class TP3Fn,class TP4Fn,class TP5Fn,class TP6Fn,class TP7Fn,class TP8Fn,class TP9Fn
#RETURN_FN=ReturnType
#RET=void
#RETURN=
*/


#include "EBaseCallback.h"

/*! 
 * \brief This class provides a callback without parameters and return value.
 */
#{TEMPLATE_CB_DECL}
class #{ECallback} : protected EBaseCallback
{
public:
  #{ECallback}() {}

  /*! Tests if the callback has been set.
   * @return \c true if the callback has been set, otherwise \c false.
   */
  operator bool() const;

  /*! Calls the callback.
   */
  #{RET} operator ()(#{PARAM_CALL}) const;


  typedef #{RET} (*ECallerFn)(const EBaseCallback &cb#{PARAM_CALL_SEP});

  #{ECallback}( ECallerFn fnCaller,
             void *pObjReceiver,
             const void *fnMember,
             size_t nSizeFnMember );

private:
  ECallerFn _fnCaller;
};



template< class Function#{TEMPLATE_PARAM_RET_SEP} >
class ECallbackCallerFn#{SUFFIX} : public #{ECallback}#{TEMPLATE_PARAM_CB_ARG}
{
public:
  ECallbackCallerFn#{SUFFIX}( Function fnCallback );

  static #{RET} caller( const EBaseCallback &cb#{PARAM_CALL_SEP} );
};

/*! \brief This class provides a Prototype for static method callback.
 */
template<class ReturnType#{TEMPLATE_PARAM}
         #{TEMPLATE_PARAM_FN}>
inline ECallbackCallerFn#{SUFFIX}< #{RETURN_FN} (*)(#{PARAM_DECL_FN})
                                   #{TEMPLATE_PARAM_RET_SEP_ARG} >
eCbCreator( #{ECallback}#{TEMPLATE_PARAM_CB_ARG} *, 
                         #{RETURN_FN} (*fn)(#{PARAM_DECL_FN}) )
{
  return ECallbackCallerFn#{SUFFIX}< #{RETURN_FN} (*)(#{PARAM_DECL_FN})
                            #{TEMPLATE_PARAM_RET_SEP_ARG}>( fn );
}

template< class Receiver, class Member#{TEMPLATE_PARAM_RET_SEP}>
class ECallbackCallerMember#{SUFFIX} : public #{ECallback}#{TEMPLATE_PARAM_CB_ARG}
{
public:
  ECallbackCallerMember#{SUFFIX}( Receiver *pObjReceiver, 
                                  const Member &fnMember );


  static #{RET} caller( const EBaseCallback &cb#{PARAM_CALL_SEP} );
};


template< class Receiver, class CallObjType
#{TEMPLATE_PARAM_FN}
#{TEMPLATE_PARAM},class ReturnType >
inline ECallbackCallerMember#{SUFFIX}< Receiver, 
                                       #{RETURN_FN} (CallObjType::*)(#{PARAM_DECL_FN})
                                       #{TEMPLATE_PARAM_RET_SEP_ARG} >
eCbCreator( #{ECallback}#{TEMPLATE_PARAM_CB_ARG} *,
            Receiver &objReceiver,
            #{RETURN_FN} (CallObjType::* const &fnMemberCallback)(#{PARAM_DECL_FN}) )
{
  typedef #{RETURN_FN} (CallObjType::*MemberCallback)(#{PARAM_DECL_FN});

  return ECallbackCallerMember#{SUFFIX}< Receiver, MemberCallback
                                #{TEMPLATE_PARAM_RET_SEP_ARG}>( &objReceiver,
                                                            fnMemberCallback );
}






// ###################################################################
// Inline methods:
// ###################################################################


#{TEMPLATE_CB_DECL}
inline 
#{ECallback}#{TEMPLATE_PARAM_CB_ARG}::operator bool() const
{
  return isValid();
}


#{TEMPLATE_CB_DECL}
inline 
#{RET}
#{ECallback}#{TEMPLATE_PARAM_CB_ARG}::operator ()(#{PARAM_CALL}) const
{
  #{RETURN} _fnCaller( *this#{CALL_LIST_SEP} );
}


#{TEMPLATE_CB_DECL}
inline
#{ECallback}#{TEMPLATE_PARAM_CB_ARG}::#{ECallback}( ECallerFn fnCaller,
                      void *pObjReceiver,
                      const void *fnMember,
                      size_t nSizeFnMember ) :
    EBaseCallback( pObjReceiver,
                   fnMember,
                   nSizeFnMember ),
    _fnCaller( fnCaller )
{
}


template< class Function#{TEMPLATE_PARAM_RET_SEP} >
inline
ECallbackCallerFn#{SUFFIX}< Function#{TEMPLATE_PARAM_RET_SEP_ARG} >::ECallbackCallerFn#{SUFFIX}( Function fnCallback ) :
    #{ECallback}#{TEMPLATE_PARAM_CB_ARG}( caller, NULL, fnCallback, 0 )
{
}


template< class Function#{TEMPLATE_PARAM_RET_SEP} >
inline #{RET}
ECallbackCallerFn#{SUFFIX}< Function#{TEMPLATE_PARAM_RET_SEP_ARG} >::caller( const EBaseCallback &cb#{PARAM_CALL_SEP} )
{
  #{RETURN} ((Function)cb._fnCallback)(#{CALL_LIST});
}


template< class Receiver, class Member#{TEMPLATE_PARAM_RET_SEP} >
inline 
ECallbackCallerMember#{SUFFIX}<Receiver,Member#{TEMPLATE_PARAM_RET_SEP_ARG}>::ECallbackCallerMember#{SUFFIX}( Receiver *pObjReceiver, 
                                                               const Member &fnMember ) :
    #{ECallback}#{TEMPLATE_PARAM_CB_ARG}( caller, pObjReceiver, &fnMember, sizeof( fnMember ) )
{
}

template< class Receiver, class Member#{TEMPLATE_PARAM_RET_SEP} >
inline #{RET}
ECallbackCallerMember#{SUFFIX}<Receiver,Member#{TEMPLATE_PARAM_RET_SEP_ARG}>::caller( const EBaseCallback &cb#{PARAM_CALL_SEP} )
{
  Receiver &objReceiver = *(Receiver *)cb._pObjReceiver;
  Member &fnMember = *(Member *)(void *)cb._fnMemberCallback;

  #{RETURN} (objReceiver.*fnMember)(#{CALL_LIST});
}

#endif // !defined(AFX_ECALLBACK9T_H__B78AA269_D476_11D2_BD55_0040053AD648__INCLUDED_)
