// Parameters for callback template code generation

/*
// ECallbackT

// Callback object   "ECallback1R"...
#ECallback=ECallbackT
// list of parameter declaration
#PARAM_CALL=
// Prefixed ',' list of parameter declaration    ", TypeParam1 p1, TypeParam2 p2"...
#PARAM_CALL_SEP=
// List of parameters type   "TypeParam1, TypeParam2"...
#PARAM_DECL=
// List of parameters type   "TypeParam1Fn, TypeParam2Fn"...
#PARAM_DECL_FN=
// list of parameters for call  "p1, p2, p3"...
#CALL_LIST=
// list of parameters for call  "p1, p2, p3" prefixed with ','...
#CALL_LIST_SEP=
// 2R" or "2"...
#SUFFIX=T
// Template paramaters for param prefixed with a comma. 
// ", class TypeParam1, class TypeParam2"
#TEMPLATE_PARAM=
// Template parameters with return type. 
// "class TypeParam1,class TypeParam2, class ReturnType"
#TEMPLATE_PARAM_RET=
// ',' if TEMPLATE_PARAM_RET is not empty
#TEMPLATE_PARAM_RET_SEP=
// List of template args without the 'class" prefixed with ',':
// , "TypeParam1,TypeParam2,ReturnType"
#TEMPLATE_PARAM_RET_SEP_ARG=
// Template parameters for Callback declaration : type of param & return type if one.
// Set to nothing if the template has no parameter & no return type.
// "<class TypeParam1, class TypeParam2, class ReturnType>"
#TEMPLATE_PARAM_CB=
#TEMPLATE_PARAM_CB_ARG=
// Template declaration for callback. Set to null if none.
#TEMPLATE_CB_DECL=
// Template parameters for the callback function prefixed with ','
#TEMPLATE_PARAM_FN=
// Return type for the function.
#RETURN_FN=ReturnType
// Return type for callback function. Should be ReturnType or void if none
#RET=void
// Set to return if callback returns a value. Null if returns nothing.
#RETURN=
*/

/*
// ECallbackRT

// Callback object   "ECallback1R"...
#ECallback=ECallbackRT
// list of parameter declaration
#PARAM_CALL=
// Prefixed ',' list of parameter declaration    ", TypeParam1 p1, TypeParam2 p2"...
#PARAM_CALL_SEP=
// List of parameters type   "TypeParam1, TypeParam2"...
#PARAM_DECL=
// List of parameters type   "TypeParam1Fn, TypeParam2Fn"...
#PARAM_DECL_FN=
// list of parameters for call  "p1, p2, p3"...
#CALL_LIST=
// list of parameters for call  "p1, p2, p3" prefixed with ','...
#CALL_LIST_SEP=
// 2R" or "2"...
#SUFFIX=RT
// Template paramaters for param prefixed with a comma. 
// ", class TypeParam1, class TypeParam2"
#TEMPLATE_PARAM=
// Template parameters with return type. 
// "class TypeParam1,class TypeParam2, class ReturnType"
#TEMPLATE_PARAM_RET=class ReturnType
// ',' if TEMPLATE_PARAM_RET is not empty
#TEMPLATE_PARAM_RET_SEP=, class ReturnType
// List of template args without the 'class" prefixed with ',':
// , "TypeParam1,TypeParam2,ReturnType"
#TEMPLATE_PARAM_RET_SEP_ARG=,ReturnType
// Template parameters for Callback declaration : type of param & return type if one.
// Set to nothing if the template has no parameter & no return type.
// "<class TypeParam1, class TypeParam2, class ReturnType>"
#TEMPLATE_PARAM_CB=<class ReturnType>
#TEMPLATE_PARAM_CB_ARG=<ReturnType>
// Template declaration for callback. Set to null if none.
#TEMPLATE_CB_DECL=template<class ReturnType>
// Template parameters for the callback function prefixed with ','
#TEMPLATE_PARAM_FN=, class ReturnTypeFn
// Return type for the function.
#RETURN_FN=ReturnTypeFn
// Return type for callback function. Should be ReturnType or void if none
#RET=ReturnType
// Set to return if callback returns a value. Null if returns nothing.
#RETURN=return
*/

/*
// ECallback1T

// Callback object   "ECallback1R"...
#ECallback=ECallback1T
// list of parameter declaration
#PARAM_CALL=TypeParam1 p1
// Prefixed ',' list of parameter declaration    ", TypeParam1 p1, TypeParam2 p2"...
#PARAM_CALL_SEP=, #{PARAM_CALL}
// List of parameters type   "TypeParam1, TypeParam2"...
#PARAM_DECL=TypeParam1
// List of parameters type   "TypeParam1Fn, TypeParam2Fn"...
#PARAM_DECL_FN=TypeParam1Fn
// list of parameters for call  "p1, p2, p3"...
#CALL_LIST=p1
// list of parameters for call  "p1, p2, p3" prefixed with ','...
#CALL_LIST_SEP=, #{CALL_LIST}
// 2R" or "2"...
#SUFFIX=1
// Template paramaters for param prefixed with a comma. 
// ", class TypeParam1, class TypeParam2"
#TEMPLATE_PARAM=, class TypeParam1
// Template parameters with return type. 
// "class TypeParam1,class TypeParam2, class ReturnType"
#TEMPLATE_PARAM_RET=class TypeParam1
// ',' if TEMPLATE_PARAM_RET is not empty
#TEMPLATE_PARAM_RET_SEP=, #{TEMPLATE_PARAM_RET}
// List of template args without the 'class" prefixed with ',':
// , "TypeParam1,TypeParam2,ReturnType"
#TEMPLATE_PARAM_RET_SEP_ARG=,TypeParam1
// Template parameters for Callback declaration : type of param & return type if one.
// Set to nothing if the template has no parameter & no return type.
// "<class TypeParam1, class TypeParam2, class ReturnType>"
#TEMPLATE_PARAM_CB=<class TypeParam1>
#TEMPLATE_PARAM_CB_ARG=<TypeParam1>
// Template declaration for callback. Set to null if none.
#TEMPLATE_CB_DECL=template#{TEMPLATE_PARAM_CB}
// Template parameters for the callback function
#TEMPLATE_PARAM_FN=,class TypeParam1Fn
// Return type for the function.
#RETURN_FN=ReturnType
// Return type for callback function. Should be ReturnType or void if none
#RET=void
// Set to return if callback returns a value. Null if returns nothing.
#RETURN=
*/


/*
// ECallback1RT

// Callback object   "ECallback1R"...
#ECallback=ECallback1RT
// list of parameter declaration
#PARAM_CALL=TypeParam1 p1
// Prefixed ',' list of parameter declaration    ", TypeParam1 p1, TypeParam2 p2"...
#PARAM_CALL_SEP=, #{PARAM_CALL}
// List of parameters type   "TypeParam1, TypeParam2"...
#PARAM_DECL=TypeParam1
// List of parameters type   "TypeParam1Fn, TypeParam2Fn"...
#PARAM_DECL_FN=TypeParam1Fn
// list of parameters for call  "p1, p2, p3"...
#CALL_LIST=p1
// list of parameters for call  "p1, p2, p3" prefixed with ','...
#CALL_LIST_SEP=, #{CALL_LIST}
// 2R" or "2"...
#SUFFIX=1R
// Template paramaters for param prefixed with a comma. 
// ", class TypeParam1, class TypeParam2"
#TEMPLATE_PARAM=, class TypeParam1
// Template parameters with return type. 
// "class TypeParam1,class TypeParam2, class ReturnType"
#TEMPLATE_PARAM_RET=class TypeParam1,class ReturnType
// ',' if TEMPLATE_PARAM_RET is not empty
#TEMPLATE_PARAM_RET_SEP=, #{TEMPLATE_PARAM_RET}
// List of template args without the 'class" prefixed with ',':
// , "TypeParam1,TypeParam2,ReturnType"
#TEMPLATE_PARAM_RET_SEP_ARG=,TypeParam1,ReturnType
// Template parameters for Callback declaration : type of param & return type if one.
// Set to nothing if the template has no parameter & no return type.
// "<class TypeParam1, class TypeParam2, class ReturnType>"
#TEMPLATE_PARAM_CB=<class TypeParam1, class ReturnType>
#TEMPLATE_PARAM_CB_ARG=<TypeParam1, ReturnType>
// Template declaration for callback. Set to null if none.
#TEMPLATE_CB_DECL=template#{TEMPLATE_PARAM_CB}
// Template parameters for the callback function prefixed with ','
#TEMPLATE_PARAM_FN=,class ReturnTypeFn, class TypeParam1Fn
// Return type for the function.
#RETURN_FN=ReturnTypeFn
// Return type for callback function. Should be ReturnType or void if none
#RET=ReturnType
// Set to return if callback returns a value. Null if returns nothing.
#RETURN=return
*/

/*
// ECallback2T

#ECallback=ECallback2T
#PARAM_CALL=TP1 p1,TP2 p2
#PARAM_CALL_SEP=, #{PARAM_CALL}
#PARAM_DECL=TP1,TP2
#PARAM_DECL_FN=TP1Fn,TP2Fn
#CALL_LIST=p1,p2
#CALL_LIST_SEP=, #{CALL_LIST}
#SUFFIX=2T
#TEMPLATE_PARAM_RET=class TP1,class TP2
#TEMPLATE_PARAM=,#{TEMPLATE_PARAM_RET}
#TEMPLATE_PARAM_RET_SEP=,#{TEMPLATE_PARAM_RET}
#TEMPLATE_PARAM_RET_SEP_ARG=,#{PARAM_DECL}
#TEMPLATE_PARAM_CB=<#{TEMPLATE_PARAM_RET}>
#TEMPLATE_PARAM_CB_ARG=<#{PARAM_DECL}>
#TEMPLATE_CB_DECL=template#{TEMPLATE_PARAM_CB}
#TEMPLATE_PARAM_FN=,class TP1Fn,class TP2Fn
#RETURN_FN=ReturnType
#RET=void
#RETURN=
*/

/*
// ECallback2RT

#ECallback=ECallback2RT
#PARAM_CALL=TP1 p1,TP2 p2
#PARAM_CALL_SEP=,#{PARAM_CALL}
#PARAM_DECL=TP1,TP2
#PARAM_DECL_FN=TP1Fn,TP2Fn
#CALL_LIST=p1,p2
#CALL_LIST_SEP=,#{CALL_LIST}
#SUFFIX=2RT
#TEMPLATE_PARAM=,class TP1,class TP2
#TEMPLATE_PARAM_RET=class TP1,class TP2,class ReturnType
#TEMPLATE_PARAM_RET_SEP=,#{TEMPLATE_PARAM_RET}
#TEMPLATE_PARAM_RET_SEP_ARG=,TP1,TP2,ReturnType
#TEMPLATE_PARAM_CB=<class TP1,class TP2,class ReturnType>
#TEMPLATE_PARAM_CB_ARG=<TP1,TP2,ReturnType>
#TEMPLATE_CB_DECL=template#{TEMPLATE_PARAM_CB}
#TEMPLATE_PARAM_FN=,class RTpFn,class TP1Fn,class TP2Fn
#RETURN_FN=RTpFn
#RET=ReturnType
#RETURN=return
*/

/*
// ECallback3T

#ECallback=ECallback3T
#PARAM_CALL=TP1 p1,TP2 p2,TP3 p3
#PARAM_CALL_SEP=, #{PARAM_CALL}
#PARAM_DECL=TP1,TP2,TP3
#PARAM_DECL_FN=TP1Fn,TP2Fn,TP3Fn
#CALL_LIST=p1,p2,p3
#CALL_LIST_SEP=, #{CALL_LIST}
#SUFFIX=3T
#TEMPLATE_PARAM_RET=class TP1,class TP2,class TP3
#TEMPLATE_PARAM=,#{TEMPLATE_PARAM_RET}
#TEMPLATE_PARAM_RET_SEP=,#{TEMPLATE_PARAM_RET}
#TEMPLATE_PARAM_RET_SEP_ARG=,#{PARAM_DECL}
#TEMPLATE_PARAM_CB=<#{TEMPLATE_PARAM_RET}>
#TEMPLATE_PARAM_CB_ARG=<#{PARAM_DECL}>
#TEMPLATE_CB_DECL=template#{TEMPLATE_PARAM_CB}
#TEMPLATE_PARAM_FN=,class TP1Fn,class TP2Fn,class TP3Fn
#RETURN_FN=ReturnType
#RET=void
#RETURN=
*/

/*
// ECallback3RT

#ECallback=ECallback3RT
#PARAM_CALL=TP1 p1,TP2 p2,TP3 p3
#PARAM_CALL_SEP=,#{PARAM_CALL}
#PARAM_DECL=TP1,TP2,TP3
#PARAM_DECL_FN=TP1Fn,TP2Fn,TP3Fn
#CALL_LIST=p1,p2,p3
#CALL_LIST_SEP=,#{CALL_LIST}
#SUFFIX=3RT
#TEMPLATE_PARAM=,class TP1,class TP2,class TP3
#TEMPLATE_PARAM_RET=class TP1,class TP2,class TP3,class ReturnType
#TEMPLATE_PARAM_RET_SEP=,#{TEMPLATE_PARAM_RET}
#TEMPLATE_PARAM_RET_SEP_ARG=,TP1,TP2,TP3,ReturnType
#TEMPLATE_PARAM_CB=<class TP1,class TP2,class TP3,class ReturnType>
#TEMPLATE_PARAM_CB_ARG=<TP1,TP2,TP3,ReturnType>
#TEMPLATE_CB_DECL=template#{TEMPLATE_PARAM_CB}
#TEMPLATE_PARAM_FN=,class RTpFn,class TP1Fn,class TP2Fn,class TP3Fn
#RETURN_FN=RTpFn
#RET=ReturnType
#RETURN=return
*/

/*
// ECallback4T

#ECallback=ECallback4T
#PARAM_CALL=TP1 p1,TP2 p2,TP3 p3,TP4 p4
#PARAM_CALL_SEP=, #{PARAM_CALL}
#PARAM_DECL=TP1,TP2,TP3,TP4
#PARAM_DECL_FN=TP1Fn,TP2Fn,TP3Fn,TP4Fn
#CALL_LIST=p1,p2,p3,p4
#CALL_LIST_SEP=, #{CALL_LIST}
#SUFFIX=4T
#TEMPLATE_PARAM_RET=class TP1,class TP2,class TP3,class TP4
#TEMPLATE_PARAM=,#{TEMPLATE_PARAM_RET}
#TEMPLATE_PARAM_RET_SEP=,#{TEMPLATE_PARAM_RET}
#TEMPLATE_PARAM_RET_SEP_ARG=,#{PARAM_DECL}
#TEMPLATE_PARAM_CB=<#{TEMPLATE_PARAM_RET}>
#TEMPLATE_PARAM_CB_ARG=<#{PARAM_DECL}>
#TEMPLATE_CB_DECL=template#{TEMPLATE_PARAM_CB}
#TEMPLATE_PARAM_FN=,class TP1Fn,class TP2Fn,class TP3Fn,class TP4Fn
#RETURN_FN=ReturnType
#RET=void
#RETURN=
*/

/*
// ECallback4RT

#ECallback=ECallback4RT
#PARAM_CALL=TP1 p1,TP2 p2,TP3 p3,TP4 p4
#PARAM_CALL_SEP=,TP1 p1,TP2 p2,TP3 p3,TP4 p4
#PARAM_DECL=TP1,TP2,TP3,TP4
#PARAM_DECL_FN=TP1Fn,TP2Fn,TP3Fn,TP4Fn
#CALL_LIST=p1,p2,p3,p4
#CALL_LIST_SEP=,p1,p2,p3,p4
#SUFFIX=4RT
#TEMPLATE_PARAM=,class TP1,class TP2,class TP3,class TP4
#TEMPLATE_PARAM_RET=class TP1,class TP2,class TP3,class TP4,class ReturnType
#TEMPLATE_PARAM_RET_SEP=,class TP1,class TP2,class TP3,class TP4,class ReturnType
#TEMPLATE_PARAM_RET_SEP_ARG=,TP1,TP2,TP3,TP4,ReturnType
#TEMPLATE_PARAM_CB=<class TP1,class TP2,class TP3,class TP4,class ReturnType>
#TEMPLATE_PARAM_CB_ARG=<TP1,TP2,TP3,TP4,ReturnType>
#TEMPLATE_CB_DECL=template<class TP1,class TP2,class TP3,class TP4,class ReturnType>
#TEMPLATE_PARAM_FN=,class RTpFn,class TP1Fn,class TP2Fn,class TP3Fn,class TP4Fn
#RETURN_FN=RTpFn
#RET=ReturnType
#RETURN=return
*/

/*
// ECallback5T

#ECallback=ECallback5T
#PARAM_CALL=TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5
#PARAM_CALL_SEP=, #{PARAM_CALL}
#PARAM_DECL=TP1,TP2,TP3,TP4,TP5
#PARAM_DECL_FN=TP1Fn,TP2Fn,TP3Fn,TP4Fn,TP5Fn
#CALL_LIST=p1,p2,p3,p4,p5
#CALL_LIST_SEP=, #{CALL_LIST}
#SUFFIX=5T
#TEMPLATE_PARAM_RET=class TP1,class TP2,class TP3,class TP4,class TP5
#TEMPLATE_PARAM=,#{TEMPLATE_PARAM_RET}
#TEMPLATE_PARAM_RET_SEP=,#{TEMPLATE_PARAM_RET}
#TEMPLATE_PARAM_RET_SEP_ARG=,#{PARAM_DECL}
#TEMPLATE_PARAM_CB=<#{TEMPLATE_PARAM_RET}>
#TEMPLATE_PARAM_CB_ARG=<#{PARAM_DECL}>
#TEMPLATE_CB_DECL=template#{TEMPLATE_PARAM_CB}
#TEMPLATE_PARAM_FN=,class TP1Fn,class TP2Fn,class TP3Fn,class TP4Fn,class TP5Fn
#RETURN_FN=ReturnType
#RET=void
#RETURN=
*/

/*
// ECallback5RT

#ECallback=ECallback5RT
#PARAM_CALL=TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5
#PARAM_CALL_SEP=,TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5
#PARAM_DECL=TP1,TP2,TP3,TP4,TP5
#PARAM_DECL_FN=TP1Fn,TP2Fn,TP3Fn,TP4Fn,TP5Fn
#CALL_LIST=p1,p2,p3,p4,p5
#CALL_LIST_SEP=,p1,p2,p3,p4,p5
#SUFFIX=5RT
#TEMPLATE_PARAM=,class TP1,class TP2,class TP3,class TP4,class TP5
#TEMPLATE_PARAM_RET=class TP1,class TP2,class TP3,class TP4,class TP5,class ReturnType
#TEMPLATE_PARAM_RET_SEP=,class TP1,class TP2,class TP3,class TP4,class TP5,class ReturnType
#TEMPLATE_PARAM_RET_SEP_ARG=,TP1,TP2,TP3,TP4,TP5,ReturnType
#TEMPLATE_PARAM_CB=<class TP1,class TP2,class TP3,class TP4,class TP5,class ReturnType>
#TEMPLATE_PARAM_CB_ARG=<TP1,TP2,TP3,TP4,TP5,ReturnType>
#TEMPLATE_CB_DECL=template<class TP1,class TP2,class TP3,class TP4,class TP5,class ReturnType>
#TEMPLATE_PARAM_FN=,class RTpFn,class TP1Fn,class TP2Fn,class TP3Fn,class TP4Fn,class TP5Fn
#RETURN_FN=RTpFn
#RET=ReturnType
#RETURN=return
*/

/*
// ECallback6T

#ECallback=ECallback6T
#PARAM_CALL=TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6
#PARAM_CALL_SEP=, #{PARAM_CALL}
#PARAM_DECL=TP1,TP2,TP3,TP4,TP5,TP6
#PARAM_DECL_FN=TP1Fn,TP2Fn,TP3Fn,TP4Fn,TP5Fn,TP6Fn
#CALL_LIST=p1,p2,p3,p4,p5,p6
#CALL_LIST_SEP=, #{CALL_LIST}
#SUFFIX=6T
#TEMPLATE_PARAM_RET=class TP1,class TP2,class TP3,class TP4,class TP5,class TP6
#TEMPLATE_PARAM=,#{TEMPLATE_PARAM_RET}
#TEMPLATE_PARAM_RET_SEP=,#{TEMPLATE_PARAM_RET}
#TEMPLATE_PARAM_RET_SEP_ARG=,#{PARAM_DECL}
#TEMPLATE_PARAM_CB=<#{TEMPLATE_PARAM_RET}>
#TEMPLATE_PARAM_CB_ARG=<#{PARAM_DECL}>
#TEMPLATE_CB_DECL=template#{TEMPLATE_PARAM_CB}
#TEMPLATE_PARAM_FN=,class TP1Fn,class TP2Fn,class TP3Fn,class TP4Fn,class TP5Fn,class TP6Fn
#RETURN_FN=ReturnType
#RET=void
#RETURN=
*/

/*
// ECallback6RT

#ECallback=ECallback6RT
#PARAM_CALL=TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6
#PARAM_CALL_SEP=,TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6
#PARAM_DECL=TP1,TP2,TP3,TP4,TP5,TP6
#PARAM_DECL_FN=TP1Fn,TP2Fn,TP3Fn,TP4Fn,TP5Fn,TP6Fn
#CALL_LIST=p1,p2,p3,p4,p5,p6
#CALL_LIST_SEP=,p1,p2,p3,p4,p5,p6
#SUFFIX=6RT
#TEMPLATE_PARAM=,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6
#TEMPLATE_PARAM_RET=class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class ReturnType
#TEMPLATE_PARAM_RET_SEP=,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class ReturnType
#TEMPLATE_PARAM_RET_SEP_ARG=,TP1,TP2,TP3,TP4,TP5,TP6,ReturnType
#TEMPLATE_PARAM_CB=<class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class ReturnType>
#TEMPLATE_PARAM_CB_ARG=<TP1,TP2,TP3,TP4,TP5,TP6,ReturnType>
#TEMPLATE_CB_DECL=template<class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class ReturnType>
#TEMPLATE_PARAM_FN=,class RTpFn,class TP1Fn,class TP2Fn,class TP3Fn,class TP4Fn,class TP5Fn,class TP6Fn
#RETURN_FN=RTpFn
#RET=ReturnType
#RETURN=return
*/

/*
// ECallback7T

#ECallback=ECallback7T
#PARAM_CALL=TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6,TP7 p7
#PARAM_CALL_SEP=, #{PARAM_CALL}
#PARAM_DECL=TP1,TP2,TP3,TP4,TP5,TP6,TP7
#PARAM_DECL_FN=TP1Fn,TP2Fn,TP3Fn,TP4Fn,TP5Fn,TP6Fn,TP7Fn
#CALL_LIST=p1,p2,p3,p4,p5,p6,p7
#CALL_LIST_SEP=, #{CALL_LIST}
#SUFFIX=7T
#TEMPLATE_PARAM_RET=class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7
#TEMPLATE_PARAM=,#{TEMPLATE_PARAM_RET}
#TEMPLATE_PARAM_RET_SEP=,#{TEMPLATE_PARAM_RET}
#TEMPLATE_PARAM_RET_SEP_ARG=,#{PARAM_DECL}
#TEMPLATE_PARAM_CB=<#{TEMPLATE_PARAM_RET}>
#TEMPLATE_PARAM_CB_ARG=<#{PARAM_DECL}>
#TEMPLATE_CB_DECL=template#{TEMPLATE_PARAM_CB}
#TEMPLATE_PARAM_FN=,class TP1Fn,class TP2Fn,class TP3Fn,class TP4Fn,class TP5Fn,class TP6Fn,class TP7Fn
#RETURN_FN=ReturnType
#RET=void
#RETURN=
*/

/*
// ECallback7RT

#ECallback=ECallback7RT
#PARAM_CALL=TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6,TP7 p7
#PARAM_CALL_SEP=,TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6,TP7 p7
#PARAM_DECL=TP1,TP2,TP3,TP4,TP5,TP6,TP7
#PARAM_DECL_FN=TP1Fn,TP2Fn,TP3Fn,TP4Fn,TP5Fn,TP6Fn,TP7Fn
#CALL_LIST=p1,p2,p3,p4,p5,p6,p7
#CALL_LIST_SEP=,p1,p2,p3,p4,p5,p6,p7
#SUFFIX=7RT
#TEMPLATE_PARAM=,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7
#TEMPLATE_PARAM_RET=class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7,class ReturnType
#TEMPLATE_PARAM_RET_SEP=,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7,class ReturnType
#TEMPLATE_PARAM_RET_SEP_ARG=,TP1,TP2,TP3,TP4,TP5,TP6,TP7,ReturnType
#TEMPLATE_PARAM_CB=<class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7,class ReturnType>
#TEMPLATE_PARAM_CB_ARG=<TP1,TP2,TP3,TP4,TP5,TP6,TP7,ReturnType>
#TEMPLATE_CB_DECL=template<class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7,class ReturnType>
#TEMPLATE_PARAM_FN=,class RTpFn,class TP1Fn,class TP2Fn,class TP3Fn,class TP4Fn,class TP5Fn,class TP6Fn,class TP7Fn
#RETURN_FN=RTpFn
#RET=ReturnType
#RETURN=return
*/

/*
// ECallback8T

#ECallback=ECallback8T
#PARAM_CALL=TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6,TP7 p7,TP8 p8
#PARAM_CALL_SEP=, #{PARAM_CALL}
#PARAM_DECL=TP1,TP2,TP3,TP4,TP5,TP6,TP7,TP8
#PARAM_DECL_FN=TP1Fn,TP2Fn,TP3Fn,TP4Fn,TP5Fn,TP6Fn,TP7Fn,TP8Fn
#CALL_LIST=p1,p2,p3,p4,p5,p6,p7,p8
#CALL_LIST_SEP=, #{CALL_LIST}
#SUFFIX=8T
#TEMPLATE_PARAM_RET=class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7,class TP8
#TEMPLATE_PARAM=,#{TEMPLATE_PARAM_RET}
#TEMPLATE_PARAM_RET_SEP=,#{TEMPLATE_PARAM_RET}
#TEMPLATE_PARAM_RET_SEP_ARG=,#{PARAM_DECL}
#TEMPLATE_PARAM_CB=<#{TEMPLATE_PARAM_RET}>
#TEMPLATE_PARAM_CB_ARG=<#{PARAM_DECL}>
#TEMPLATE_CB_DECL=template#{TEMPLATE_PARAM_CB}
#TEMPLATE_PARAM_FN=,class TP1Fn,class TP2Fn,class TP3Fn,class TP4Fn,class TP5Fn,class TP6Fn,class TP7Fn,class TP8Fn
#RETURN_FN=ReturnType
#RET=void
#RETURN=
*/

/*
// ECallback8RT

#ECallback=ECallback8RT
#PARAM_CALL=TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6,TP7 p7,TP8 p8
#PARAM_CALL_SEP=,TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6,TP7 p7,TP8 p8
#PARAM_DECL=TP1,TP2,TP3,TP4,TP5,TP6,TP7,TP8
#PARAM_DECL_FN=TP1Fn,TP2Fn,TP3Fn,TP4Fn,TP5Fn,TP6Fn,TP7Fn,TP8Fn
#CALL_LIST=p1,p2,p3,p4,p5,p6,p7,p8
#CALL_LIST_SEP=,#{CALL_LIST}
#SUFFIX=8RT
#TEMPLATE_PARAM=,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7,class TP8
#TEMPLATE_PARAM_RET=class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7,class TP8,class ReturnType
#TEMPLATE_PARAM_RET_SEP=,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7,class TP8,class ReturnType
#TEMPLATE_PARAM_RET_SEP_ARG=,TP1,TP2,TP3,TP4,TP5,TP6,TP7,TP8,ReturnType
#TEMPLATE_PARAM_CB=<class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7,class TP8,class ReturnType>
#TEMPLATE_PARAM_CB_ARG=<TP1,TP2,TP3,TP4,TP5,TP6,TP7,TP8,ReturnType>
#TEMPLATE_CB_DECL=template<class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7,class TP8,class ReturnType>
#TEMPLATE_PARAM_FN=,class RTpFn,class TP1Fn,class TP2Fn,class TP3Fn,class TP4Fn,class TP5Fn,class TP6Fn,class TP7Fn,class TP8Fn
#RETURN_FN=RTpFn
#RET=ReturnType
#RETURN=return
*/

/*
// ECallback9T

#ECallback=ECallback9T
#PARAM_CALL=TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6,TP7 p7,TP8 p8,TP9 p9
#PARAM_CALL_SEP=, #{PARAM_CALL}
#PARAM_DECL=TP1,TP2,TP3,TP4,TP5,TP6,TP7,TP8,TP9
#PARAM_DECL_FN=TP1Fn,TP2Fn,TP3Fn,TP4Fn,TP5Fn,TP6Fn,TP7Fn,TP8Fn,TP9Fn
#CALL_LIST=p1,p2,p3,p4,p5,p6,p7,p8,p9
#CALL_LIST_SEP=, #{CALL_LIST}
#SUFFIX=9T
#TEMPLATE_PARAM_RET=class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7,class TP8,class TP9
#TEMPLATE_PARAM=,#{TEMPLATE_PARAM_RET}
#TEMPLATE_PARAM_RET_SEP=,#{TEMPLATE_PARAM_RET}
#TEMPLATE_PARAM_RET_SEP_ARG=,#{PARAM_DECL}
#TEMPLATE_PARAM_CB=<#{TEMPLATE_PARAM_RET}>
#TEMPLATE_PARAM_CB_ARG=<#{PARAM_DECL}>
#TEMPLATE_CB_DECL=template#{TEMPLATE_PARAM_CB}
#TEMPLATE_PARAM_FN=,class TP1Fn,class TP2Fn,class TP3Fn,class TP4Fn,class TP5Fn,class TP6Fn,class TP7Fn,class TP8Fn,class TP9Fn
#RETURN_FN=ReturnType
#RET=void
#RETURN=
*/

/*
// ECallback9RT

#ECallback=ECallback9RT
#PARAM_CALL=TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6,TP7 p7,TP8 p8,TP9 p9
#PARAM_CALL_SEP=,TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6,TP7 p7,TP8 p8,TP9 p9
#PARAM_DECL=TP1,TP2,TP3,TP4,TP5,TP6,TP7,TP8,TP9
#PARAM_DECL_FN=TP1Fn,TP2Fn,TP3Fn,TP4Fn,TP5Fn,TP6Fn,TP7Fn,TP8Fn,TP9Fn
#CALL_LIST=p1,p2,p3,p4,p5,p6,p7,p8,p9
#CALL_LIST_SEP=,#{CALL_LIST}
#SUFFIX=9RT
#TEMPLATE_PARAM=,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7,class TP8,class TP9
#TEMPLATE_PARAM_RET=class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7,class TP8,class TP9,class ReturnType
#TEMPLATE_PARAM_RET_SEP=,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7,class TP8,class TP9,class ReturnType
#TEMPLATE_PARAM_RET_SEP_ARG=,TP1,TP2,TP3,TP4,TP5,TP6,TP7,TP8,TP9,ReturnType
#TEMPLATE_PARAM_CB=<class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7,class TP8,class TP9,class ReturnType>
#TEMPLATE_PARAM_CB_ARG=<TP1,TP2,TP3,TP4,TP5,TP6,TP7,TP8,TP9,ReturnType>
#TEMPLATE_CB_DECL=template<class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class TP7,class TP8,class TP9,class ReturnType>
#TEMPLATE_PARAM_FN=,class RTpFn,class TP1Fn,class TP2Fn,class TP3Fn,class TP4Fn,class TP5Fn,class TP6Fn,class TP7Fn,class TP8Fn,class TP9Fn
#RETURN_FN=RTpFn
#RET=ReturnType
#RETURN=return
*/
