// EClassId.cpp: implementation of the EClassId class.
//
//////////////////////////////////////////////////////////////////////

#include "usuel.hpp"
#include "EClassId.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

EClassId *EClassId::_pFirstClassId =NULL;

EClassId::EClassId( const EString &strClassName,
                    EBaseClass *(*pfnCreateNewObject)() )
{
  EASSERT( strClassName.length() );     // The class must have a name.
  _strClassName = strClassName;
  _pfnCreateNewObject = pfnCreateNewObject;
  
  _pNextClassId = _pFirstClassId;   // build linked list of class id.
  _pFirstClassId = this;
  _nVersion =0;
}

EClassId::EClassId( const EString &strClassName,
                    EBaseClass *(*pfnCreateNewObject)(),
                    UL nVersion )
{
  EASSERT( strClassName.length() );     // The class must have a name.
  _strClassName = strClassName;
  _pfnCreateNewObject = pfnCreateNewObject;
  
  _pNextClassId = _pFirstClassId;   // build linked list of class id.
  _pFirstClassId = this;
  _nVersion = nVersion;
}


const EClassId *
EClassId::findClass( const EString &strClassName )
{
  const EClassId *pClsid = firstClass();
  while ( pClsid )
  {
    if ( strClassName  ==  pClsid->className() )   // class found !
      break;
    pClsid = pClsid->nextClass();
  }
  return pClsid;
}

