// ERandomItT.h: interface for the ERandomItT class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ERANDOMITT_H__32671F91_3F99_11D3_BE24_0040053AD648__INCLUDED_)
#define AFX_ERANDOMITT_H__32671F91_3F99_11D3_BE24_0040053AD648__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "EIteratorT.h"



/*! \class ERandomItT<Item>
 * \include "ERandomItT.h"
 * \brief Template that provides random iteration through a collection.
 *
 */
template<class Item>
class ERandomItT : public EIteratorT<Item>
{
public:
  ERandomItT() {}
  virtual ~ERandomItT() {}

  /*! Set the iterator at a given position.
   * @param nPos New position of the iterator (zero based).
   */
  virtual void seekTo( SL nPos ) =0;

  /*! Get an element at a given position.
   * @param nPos Position of the element.
   */
  virtual Item &at( SL nPos );
};


// Template : ERandomIt<Item> implementation
// -----------------------------------------

template<class Item>
Item &
ERandomItT<Item>::at( SL nPos )
{
  seekTo( nPos );
  return item();
}


#endif // !defined(AFX_ERANDOMITT_H__32671F91_3F99_11D3_BE24_0040053AD648__INCLUDED_)
