// EStoreObjectDef.cpp: implementation of the EStoreObjectDef class.
//
//////////////////////////////////////////////////////////////////////

#include "usuel.hpp"
#include "EString.hpp"
#include "EStoreOtDef.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

EStoreOtDef::EStoreOtDef()
{

}


EStoreOtDef::~EStoreOtDef()
{

}


EStoreObjectType 
EStoreOtDef::objectType( const EString &strObjectType ) const
{
  const EStoreObjectType *pnType = _bhashDefObject.lookUpByItem( strObjectType );
  if ( !pnType )
    return esotpNone;
  return *pnType;
}


const EString &
EStoreOtDef::objectTypeName( EStoreObjectType esotpObject ) const
{
  const EString *pstrName = _bhashDefObject.lookUp( esotpObject );
  EASSERT( pstrName );
  if ( pstrName )
    return *pstrName;
  return EString::nullString;
}


EStorePrpType
EStoreOtDef::prpType( const EString &strPrpType ) const
{
  PrpTypeInfo prpInfo( strPrpType, EStoreOtPrp::pvtpNone );
  const EStorePrpType *pnType = _bhashDefPrp.lookUpByItem( prpInfo );
  if ( !pnType )
    return esptpNone;
  return *pnType;
}


const EStoreOtDef::PrpTypeInfo &
EStoreOtDef::prpTypeInfo( const EString &strPrpType ) const
{
  PrpTypeInfo prpInfo( strPrpType, EStoreOtPrp::pvtpNone );
  const PrpTypeInfo *pInfo = _bhashDefPrp.lookUpItem( prpInfo );
  EASSERT( pInfo );

  return *pInfo;
}


const EString &
EStoreOtDef::prpTypeName( EStorePrpType esptpPrp ) const
{
  const PrpTypeInfo *pInfo = _bhashDefPrp.lookUp( esptpPrp );
  EASSERT( pInfo );
  if ( pInfo )
    return pInfo->_strPrpTypeName;
  return EString::nullString;
}


void 
EStoreOtDef::addObjectType( EStoreObjectType esotpObject,
                                const EString &strObjectType )
{
  _bhashDefObject.add( esotpObject, strObjectType );
}


void 
EStoreOtDef::addPrpType( EStorePrpType esptpPrp,
                         const EString &strPrpType,
                         EStoreOtPrp::PrpValueType pvtpPrp )
{
  _bhashDefPrp.add( esptpPrp, 
                    PrpTypeInfo( strPrpType, pvtpPrp ) );
}

