// EStoreObjectWriter.h: interface for the EStoreObjectWriter class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ESTOREOTWRITER_H__27A1D182_7332_11D3_BE8F_0040053AD648__INCLUDED_)
#define AFX_ESTOREOTWRITER_H__27A1D182_7332_11D3_BE8F_0040053AD648__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "EStoreOtDef.h"
#include "EStoreOtPrp.h"
class EDataStream;
class EStoreOtReaderContext;
class EStoreOtDef;

class EStoreOtWriter  
{
public:
	EStoreOtWriter();
	virtual ~EStoreOtWriter();

  void setDataStream( EDataStream &streamOut );
  void setObjectDef( EStoreOtDef *pDef );

  EStoreOtDef &def();

  /** Call this method to finish the building.
   */
  virtual void finish();

  virtual void buildObject( EStoreObjectType esotpObject );
  
  virtual void buildObjectClose();
  
  virtual void buildProperty( EStoreOtPrp &prp );

  void buildProperty( EStorePrpType esptpPrp, 
                      SL nValue );

  void buildProperty( EStorePrpType esptpPrp, 
                      UL ulValue );

  void buildProperty( EStorePrpType esptpPrp, 
                      double flValue );

  void buildProperty( EStorePrpType esptpPrp, 
                      const EString &strValue );
protected:
  void pushLine( const EString &strLine );
  void addIndent( EString &strLine );

private:
  EDataStream *_pstreamOut;
  SL _nObjectLevel;

  /** Pointer on the definition use for writing.
   */
  EStoreOtDef *_pdefObject;
};




inline void 
EStoreOtWriter::addIndent( EString &strLine )
{
  SL nCount = _nObjectLevel;
  while ( nCount-- > 0 )
    strLine += _T( ' ' );
} 


inline void 
EStoreOtWriter::setDataStream( EDataStream &streamOut )
{
  _pstreamOut = &streamOut;
}


inline void 
EStoreOtWriter::setObjectDef( EStoreOtDef *pDef )
{
  _pdefObject = pDef;
}


inline EStoreOtDef &
EStoreOtWriter::def()
{
  EASSERT( _pdefObject );
  return *_pdefObject;
}


inline void 
EStoreOtWriter::buildProperty( EStorePrpType esptpPrp, SL nValue )
{
  buildProperty( EStoreOtPrp( esptpPrp, nValue ) );
}


inline void 
EStoreOtWriter::buildProperty( EStorePrpType esptpPrp, UL ulValue )
{
  buildProperty( EStoreOtPrp( esptpPrp, ulValue ) );
}


inline void 
EStoreOtWriter::buildProperty( EStorePrpType esptpPrp, 
                                   double flValue )
{
  buildProperty( EStoreOtPrp( esptpPrp, flValue ) );
}


inline void 
EStoreOtWriter::buildProperty( EStorePrpType esptpPrp, 
                                   const EString &strValue )
{
  buildProperty( EStoreOtPrp( esptpPrp, strValue ) );
}



#endif // !defined(AFX_ESTOREOTWRITER_H__27A1D182_7332_11D3_BE8F_0040053AD648__INCLUDED_)
