// EVector2T.h: interface for the EVector2T class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EVECTOR2_H__BB179D76_5A24_11D2_AE7A_A751456EB561__INCLUDED_)
#define AFX_EVECTOR2_H__BB179D76_5A24_11D2_AE7A_A751456EB561__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "EVector.h"


template<class EGmtVal>
class EVector2T : public EVector<2,EGmtVal>  
{
public:
  EVector2T() {}

	EVector2T( EGmtVal fX, 
            EGmtVal fY );

  ~EVector2T() {}

  EGmtVal x() const;

  EGmtVal y() const;

  void xy( EGmtVal &fX, 
           EGmtVal &fY );

  EVector2T &set( EGmtVal fX, 
                 EGmtVal fY );

};

typedef EVector2T<float> EVector2;
typedef EVector2T<double> EVector2d;
typedef EVector2T<SL> EVector2I;


template<class EGmtVal>
inline 
EVector2T<EGmtVal>::EVector2T( EGmtVal fX, 
                               EGmtVal fY )
{
  set( fX, fY );
}

template<class EGmtVal>
inline EGmtVal 
EVector2T<EGmtVal>::x() const
{
  return coord( 0 );
}

template<class EGmtVal>
inline EGmtVal 
EVector2T<EGmtVal>::y() const
{
  return coord( 1 );
}

template<class EGmtVal>
inline void 
EVector2T<EGmtVal>::xy( EGmtVal &fX, 
                        EGmtVal &fY )
{
  fX = x();
  fY = y();
}

template<class EGmtVal>
inline EVector2T<EGmtVal> &
EVector2T<EGmtVal>::set( EGmtVal fX, 
                        EGmtVal fY )
{
  setCoord( 0, fX );
  setCoord( 1, fY );
  return *this;
}


#endif // !defined(AFX_EVECTOR2_H__BB179D76_5A24_11D2_AE7A_A751456EB561__INCLUDED_)
