// ###########################################################################
// File: EMATH.CPP
// (c)Copyright 10/1997, Lepilleur Baptiste (Aka Elyon from Zuul Design)
// Version 1.2
// ###########################################################################


/* HST:
 * 02/04/98: - remove x local variable in lSinusInit().
 *           - add cast on return for frand().
 * 19/09/98: - Replace eabs() macro by a template.
 *           - Add esqr() template.
 *           - Add warning for use of EABS macro in usuel.hpp.
 */

/** TODO:
 * - better initialisation of the random table.
 */


#include <stdlib.h>
#include <math.h>
#include "usuel.hpp"
#include "emath.hpp"

void emathInit()
{
  lSinusInit();
  fastRndInit( 0 );
}


// ###########################################################################
// ###########################################################################
// Sinus & Cosinus << 16
// #####################Last change: 26/10/97 16h40mn#########################
// ###########################################################################

// sinus table. -> lSinusTable[0] = unite...
SL lSinusTable[ sinusTableSize ];


/// Initialize sinus table
void lSinusInit()
{
  SL n;

  for ( n=0; n < sinusTableSize; ++n )
    lSinusTable[ n ] = (SL)( unite * sin(M_PI *
                            (float)(n) /(float)(sinusTableSize/2)) );
}

// ###########################################################################
// ###########################################################################
// Random Number
// #####################Last change: 26/10/97 17h24mn#########################
// ###########################################################################

static UL fastRandomTable[ 55 ];
static UL posRandomTable =0;

void fastRndInit( UL seed )
{
  SL cpt;
  UL v;

  srand( seed );

  for ( cpt =0; cpt <55; ++cpt )
  {
    SL cpt2;

    v = rand();
    for ( cpt2 =0; cpt2 <8; ++cpt2 )
      v = (v <<4) |rand();
    fastRandomTable[ cpt ] =v;
  }
  posRandomTable =0;
}

UL fastRnd()
{
  if ( posRandomTable >= 55 )
    posRandomTable -= 55;
  SL nextPos = posRandomTable +24;
  if ( nextPos > 54 )              // modulo 55
    nextPos -= 55;
  fastRandomTable[ posRandomTable ] ^= fastRandomTable[ nextPos ];
  return fastRandomTable[ posRandomTable++ ];
}



/// return a random number between 0.0 and 1.0
float frand()
{
  double r = (double)rand();
  double deuxp32 = (double)(1<<31) *2.0;
  return (float)(r / deuxp32);
}

// ############################ EOF EMATH.CPP ################################
// ############################ EOF EMATH.CPP ################################
// ############################ EOF EMATH.CPP ################################

