// ###########################################################################
// File: EXCIODEV.HPP
// (c)Copyright 08/1997, Lepilleur Baptiste (Aka Elyon from Zuul Design)
// Version 1.1
// ###########################################################################


#ifndef EXCIODEV_HPP_INCLUDED


// Includes:
// #####################Last change: 22/08/97 19h46mn#########################

// Constantes:
// #####################Last change: 22/08/97 19h46mn#########################


// Macros:
// #####################Last change: 22/08/97 19h46mn#########################


// Types:
// #####################Last change: 22/08/97 19h46mn#########################

class EXCIODevice : public EXC
{
public:
    EXC_TYPE( EXCIODevice );

    enum Cause {
        endOfFile,
        ioError,
        createError
    };

    /** Constructor.
     * @param _cause cause of the exception.
     */
    EXCIODevice( Cause _cause );

    /// return the cause of the exception
    EXCIODevice::Cause cause() const;

    /** Dump information on stderr.
     */
    virtual void dump();

private:
    Cause causeEXC;
};

inline void EXCIODevice::dump()
{
  EXC::dump();
  const char *s;
  switch ( causeEXC )
  {
    case endOfFile: s = "End Of File"; break;
    case ioError: s = "I/O Error"; break;
    case createError: s = "Create Error"; break;
    default: s = "Unkow Cause !!!!"; break;
  }
  fprintf( stderr, " Cause [%s]\n", s );
}

/** Constructor.
 * @param _cause cause of the exception.
 */
inline EXCIODevice::EXCIODevice( Cause _cause ) :
    EXC( "I/O Device exception")
{
    causeEXC = _cause;
}

/// return the cause of the exception
inline EXCIODevice::Cause EXCIODevice::cause() const
{
    return causeEXC;
}

// inlines:
// #####################Last change: 22/08/97 19h46mn#########################



#define EXCIODEV_HPP_INCLUDED
#endif


// ########################### EOF EXCIODEV.HPP ##############################
// ########################### EOF EXCIODEV.HPP ##############################
// ########################### EOF EXCIODEV.HPP ##############################


