// ###########################################################################
// File: USUEL.HPP
// (c)Copyright 08/1997, Lepilleur Baptiste (Aka Elyon de Zuul Design)
// ###########################################################################


#ifndef USUEL_H_ETOOLLIB_INCLUDED
#define USUEL_H_ETOOLLIB_INCLUDED

#include "EToolLibCompilerSettings.h"
#include "EToolLibMacros.h"




// Includes:
// ###########################################################################

#ifdef WIN32
#include "tchar.h"
#endif

// #######################Created: 04/04/96 19h08mn###########################
// Constantes:
// #####################Last change: 04/04/96 19h08mn#########################

#define true 1
#define false 0
#define ENIL 0
#define UL_MAX 0xffffffff

// #######################Created: 04/04/96 19h08mn###########################
// Macros:
// #####################Last change: 04/04/96 19h08mn#########################

/*! Define macro to indicate that debugging is enabled.
 */
#ifdef _DEBUG
#define EDBG
#endif

/** Class Identification.
 * @param Type name of the class.
 */
#define CLASS_NAME( Type ) \
    virtual const char *className() const { return #Type; }


/*! Portable warning macro.
 * msg Message to print.
 */
#ifdef _MSC_VER
#  define EWARNING( msg ) \#pragma message( msg )
#else
#  define EWARNING( msg ) 
#endif


// #######################Created: 04/04/96 19h08mn###########################
// Types:
// #####################Last change: 04/04/96 19h08mn#########################

#ifdef _MSC_VER
#define EBOOL_IS_BASE_TYPE      // visual c++ support base boolean type
#endif

typedef double DBL;
typedef signed char SB;
typedef signed short  SW;
typedef int SL;
typedef unsigned char UB;
typedef unsigned short UW;
typedef unsigned int UL;
#ifndef EBOOL_IS_BASE_TYPE
typedef unsigned char bool;
#endif


// #######################Created: 04/04/96 19h08mn###########################
// Prototypes:
// #####################Last change: 04/04/96 19h08mn#########################

// Includes:
// #####################Last change: 21/06/96 19h22mn#########################

#ifndef _STDIO_H_INCLUDED
#include <stdio.h>
#endif
#ifndef _STDLIB_H_INCLUDED
#include <stdlib.h>
#endif
#include <stdarg.h>
#include "asminlin.h"
#include "exc.hpp"

// Exceptions
// #####################Last change: 22/12/95 19h17mn#########################

NEWEXC( EXCOutOfMemory,
        "Out Of Memory" )


// #######################Created: 04/04/96 19h08mn###########################
// Inlines:
// #####################Last change: 04/04/96 19h08mn#########################

#define sqr( x ) EWARNING ( "sqr() is now obsolete. Use esqr() instead" )


template <class T>
inline void xchg( T &a, T &b )
{
  T t = a;
  a = b;
  b = t;
}

inline void *erealloc( void *pBlock, size_t nSize )
{
  pBlock = realloc( pBlock, nSize );
  if ( nSize > 0  &&  !pBlock )
  {
    ETHROW( EXCOutOfMemory() );
  }
  return pBlock;
}

inline void *emalloc( size_t nSize )
{
  void *pBlock = malloc( nSize );
  if ( nSize > 0  &&  !pBlock )
  {
    ETHROW( EXCOutOfMemory() );
  }
  return pBlock;
}

inline void efree( void *pBlock )
{
  free( pBlock );
}
/*
#define realloc SHOULD_USE_erealloc
#define malloc SHOULD_USE_emalloc
#define free SHOULD_USE_efree
*/

#endif


// ############################# EOF USUEL.H #################################
// ############################# EOF USUEL.H #################################
// ############################# EOF USUEL.H #################################

