// EwgClipboardManager.h: interface for the EwgClipboardManager class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EWGCLIPBOARDMANAGER_H__4E59838F_1940_407C_BEF8_D2B6E1C88F05__INCLUDED_)
#define AFX_EWGCLIPBOARDMANAGER_H__4E59838F_1940_407C_BEF8_D2B6E1C88F05__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class EwgClipboardManager  
{
public:
	EwgClipboardManager();
	virtual ~EwgClipboardManager();

  /*! Read CF_TEXT from the clipboard and copy it to the specified buffer.
   * @param buffer Buffer into which the text is written. The buffer must be
   *               open for writing.
   * @return \c true if success, \c false if a problem occurs.
   * @exception EXCIODevice.
   */
  bool readTextFromClipboard( EBuffer &buffer );


  /*! Write the specified CF_TEXT buffer to the clipboard.
   * @param buffer Buffer to copy to the clipboard. Must be open for reading
   *               and positionned where the copying starts.
   * @return \c true if success, \c false if a problem occurs.
   * @exception EXCIODevice.
   */
  bool writeTextToClipboard( EBuffer &buffer );
};

#endif // !defined(AFX_EWGCLIPBOARDMANAGER_H__4E59838F_1940_407C_BEF8_D2B6E1C88F05__INCLUDED_)
