// EwgShellBridge.cpp: implementation of the EwgShellBridge class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "EwgShellBridge.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

EwgShellBridge::EwgShellBridge()
{

}

EwgShellBridge::~EwgShellBridge()
{

}


/*
Receives a value greater than 32 if successful, or an error value that is less than or equal to 32 otherwise. Error values can be one of the following: SE_ERR_FNF  File not found. 
SE_ERR_PNF  Path not found. 
SE_ERR_ACCESSDENIED  Access denied. 
SE_ERR_OOM  Out of memory. 
SE_ERR_DLLNOTFOUND  Dynamic-link library not found. 
SE_ERR_SHARE  Cannot share an open file. 
SE_ERR_ASSOCINCOMPLETE  File association information not complete. 
SE_ERR_DDETIMEOUT  DDE operation timed out. 
SE_ERR_DDEFAIL  DDE operation failed. 
SE_ERR_DDEBUSY  DDE operation is busy. 
SE_ERR_NOASSOC  File association not available. 
*/
bool
EwgShellBridge::Execute( CString fileName )
{
  const DWORD maxErrorValue = 32;
  CWnd *pMainWindow = AfxGetApp() != NULL ? AfxGetApp()->m_pMainWnd : NULL;
  HWND hWndMsg = pMainWindow != NULL ? pMainWindow->GetSafeHwnd() : NULL;
  DWORD result = (DWORD)ShellExecute( hWndMsg,
                                      NULL,
                                      fileName, 
                                      NULL, 
                                      NULL, 
                                      SW_SHOWNORMAL );
  if ( result < maxErrorValue )
    return false;
  return true;
}
