// TabEOS.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "TabEOS.h"
#include "DlgEOSBadWord.h"
#include "TtrGlobalSetting.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTabEOS property page

IMPLEMENT_DYNCREATE(CTabEOS, CPropertyPage)

CTabEOS::CTabEOS() : CPropertyPage(CTabEOS::IDD)
{
	//{{AFX_DATA_INIT(CTabEOS)
	m_modeEOS = FALSE;
	m_sWordEOS = _T("");
	m_sEOSChars = _T("");
	_bRightMargin = FALSE;
	_nRightMargin = 0;
	//}}AFX_DATA_INIT
}

CTabEOS::~CTabEOS()
{
}

void CTabEOS::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTabEOS)
	DDX_Control(pDX, IDC_LIST_WORDEOS, m_ctrlListWordEOS);
	DDX_Check(pDX, IDC_CHECK_MODE_EOS, m_modeEOS);
	DDX_Text(pDX, IDC_EDIT_WORD_EOS, m_sWordEOS);
	DDX_Text(pDX, IDC_EDIT_EOSCHARS, m_sEOSChars);
	DDX_Check(pDX, IDC_CHECK_RIGHT_MARGIN, _bRightMargin);
	DDX_Text(pDX, IDC_EDIT_RIGHT_MARGIN, _nRightMargin);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTabEOS, CPropertyPage)
	//{{AFX_MSG_MAP(CTabEOS)
	ON_BN_CLICKED(IDC_BUTTON_EOS_ADD_WORD, OnButtonEosAddWord)
	ON_EN_KILLFOCUS(IDC_EDIT_EOSCHARS, OnKillfocusEditEoschars)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// set member datas according to TTR mode
void CTabEOS::SetMode( const TtrGlobalSetting& mode )
{
  m_modeEOS = mode.getFormatModeEos();
  m_sEOSChars = mode.getFormatModeEosChar().cstr();
//  m_lsWordEOS.Copy( mode.m_lsWordEOS );
  _bRightMargin = mode.getFormatUseRightMargin();
  _nRightMargin = mode.getFormatRightMargin();
}

// get TTR mode matching member datas 
void CTabEOS::GetMode( TtrGlobalSetting& mode ) const
{
  mode.setFormatModeEos( m_modeEOS );
  mode.setFormatModeEosChar( (LPCTSTR)m_sEOSChars );
//  mode.m_lsWordEOS.Copy( m_lsWordEOS );
  mode.setFormatUseRightMargin( _bRightMargin );
  mode.setFormatRightMargin( _nRightMargin );
}


/////////////////////////////////////////////////////////////////////////////
// CTabEOS message handlers

void CTabEOS::OnButtonEosAddWord() 
{
  UpdateData();
  if ( m_sWordEOS.GetLength() == 0 )
  {
    AfxMessageBox( IDS_EOS_WORD_MISSING );
  }
  else
  {
    if ( !TtrGlobalSetting::WordEOSValid( m_sWordEOS, m_sEOSChars ) ) // the word is valid
    {
      AfxMessageBox( IDS_EOS_BAD_WORD );
    }
    else
    {
      m_lsWordEOS.Add( m_sWordEOS );
      m_ctrlListWordEOS.AddString( (LPCTSTR)m_sWordEOS );
      m_sWordEOS.Empty();
      UpdateData( FALSE );   // erase word field
    }
  }
}

BOOL CTabEOS::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();

  int nb = m_lsWordEOS.GetSize();
  int cpt;
  for ( cpt =0; cpt < nb; ++cpt )
    m_ctrlListWordEOS.AddString( (LPCTSTR) m_lsWordEOS.GetAt( cpt ) );
	
	return TRUE;  
}

// EOS chars change;
void CTabEOS::OnKillfocusEditEoschars() 
{
	CString sOldEOSChars = m_sEOSChars;
  UpdateData();
  if ( m_sEOSChars != sOldEOSChars )  // EOS chars changed ! => check if all word in list 
  {                                   // are still valid.
    int nb = m_lsWordEOS.GetSize();
    int cpt;
    CStringArray lsBadWord;
    for ( cpt =0; cpt < nb; ++cpt )
      if ( !TtrGlobalSetting::WordEOSValid( m_lsWordEOS[ cpt ], m_sEOSChars ) )  // not valid
        lsBadWord.Add( m_lsWordEOS[ cpt ] );
    if ( lsBadWord.GetSize() )    // there is some bad word !
    {
      CDlgEOSBadWord dlg( lsBadWord );
      if ( dlg.DoModal() == IDCANCEL ) // cancel change
      {
        m_sEOSChars = sOldEOSChars;
        UpdateData( FALSE );
      }
      else  // remove words
      {
        int nbBad = lsBadWord.GetSize();
        for ( cpt =0; cpt < nbBad; ++cpt )
        {
          int idx = m_ctrlListWordEOS.FindStringExact( -1, lsBadWord[ cpt ] );
          ASSERT( idx != LB_ERR );
          m_ctrlListWordEOS.DeleteString( idx );
        }
      }
    }
  }
}
