// TabSavingSetting.cpp : implementation file
//

// Notes: A value of -1 for radio button means that none are selected.

#include "stdafx.h"
#include "resource.h"
#include "TabSavingSetting.h"
#include "TtrGlobalSetting.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTabSavingSetting property page

IMPLEMENT_DYNCREATE(CTabSavingSetting, CPropertyPage)

CTabSavingSetting::CTabSavingSetting() : CPropertyPage(CTabSavingSetting::IDD)
{
	//{{AFX_DATA_INIT(CTabSavingSetting)
	m_bJumpOneLine = FALSE;
	m_nNbIndent = 0;
	m_nIndentType = -1;
	_bRemoveEndingHyphen = FALSE;
	_nWrappingCol = 72;
	//}}AFX_DATA_INIT
}

CTabSavingSetting::~CTabSavingSetting()
{
}

void CTabSavingSetting::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTabSavingSetting)
	DDX_Check(pDX, IDC_CHECK_JUMP_ONE_LINE, m_bJumpOneLine);
	DDX_Text(pDX, IDC_EDIT_NUMBER_INDENTATION, m_nNbIndent);
	DDV_MinMaxInt(pDX, m_nNbIndent, 0, 99);
	DDX_Radio(pDX, IDC_RADIO_TABULATION, m_nIndentType);
	DDX_Check(pDX, IDC_CHECK_REMOVE_ENDING_HYPHEN, _bRemoveEndingHyphen);
	DDX_Text(pDX, IDC_EDIT_WRAPPING_COL, _nWrappingCol);
	DDV_MinMaxInt(pDX, _nWrappingCol, 1, 999999999);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTabSavingSetting, CPropertyPage)
	//{{AFX_MSG_MAP(CTabSavingSetting)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// set member datas according to TTR mode
void CTabSavingSetting::SetMode( const TtrGlobalSetting& mode )
{
  
  switch ( mode.getWriterLineMode() )
  {
  default:
  case wslmIndentAsOriginal: m_nIndentType = radioKeepOriginal; break;
  case wslmIndentWithTab: m_nIndentType = radioTabs; break;
  case wslmIndentWithSpace: m_nIndentType = radioSpaces; break;
  }

  m_bJumpOneLine = mode.getWriterJumpOneLine();
  m_nNbIndent = mode.getWriterReindentSize();
  _bRemoveEndingHyphen = mode.getWriterRemoveEndingHyphen();
  _nWrappingCol = mode.getWriterWrappingCol();
}

// get TTR mode matching member datas 
void CTabSavingSetting::GetMode( TtrGlobalSetting& mode ) const
{
  TtrWriterLineMode nMode;
  switch ( m_nIndentType )
  {
  case radioKeepOriginal: nMode = wslmIndentAsOriginal; break;
  case radioTabs: nMode = wslmIndentWithTab; break;
  case radioSpaces: nMode = wslmIndentWithSpace; break;
  }
  mode.setWriterLineMode( nMode );
  mode.setWriterJumpOneLine( m_bJumpOneLine );
  mode.setWriterReindentSize( m_nNbIndent );
  mode.setWriterRemoveEndingHyphen( _bRemoveEndingHyphen );
  mode.setWriterWrappingCol( _nWrappingCol );
}


/////////////////////////////////////////////////////////////////////////////
// CTabSavingSetting message handlers
