// TtrEnclosureList.cpp: implementation of the TtrEnclosureList class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TtrEnclosureList.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TtrEnclosureList::TtrEnclosureList()
{
}


TtrEnclosureList::TtrEnclosureList( const TtrEnclosureList &enclosureList )
{
  copy( enclosureList );
}


TtrEnclosureList::~TtrEnclosureList()
{
}


TtrEnclosureList &
TtrEnclosureList::operator =( const TtrEnclosureList &enclosureList )
{
  copy( enclosureList );
  return *this;
}


void 
TtrEnclosureList::copy( const TtrEnclosureList &enclosureList )
{
  _vpEnclosure.reset();
  ArrayEnclosure::EIterator it( enclosureList._vpEnclosure );
  for ( it.begin(); !it.isEnd(); it.next() )
  {
    addEnclosure( new TtrEnclosure( it.item()->getOpening(),
                                    it.item()->getClosure() ) );
  }

  fireRenewed();
}


void
TtrEnclosureList::fireRenewed()
{
  ListenerList::ItListener itListener( _listListener.iterator() );
  for ( ; !itListener.isEnd(); itListener.next() )
    itListener.item()->enclosureListRenewed( *this );
}


void 
TtrEnclosureList::addEnclosure( TtrEnclosure *pEnclosure )
{
  if ( !pEnclosure )
    return;

  ArrayEnclosure::EIterator it( _vpEnclosure );
  for ( it.begin(); !it.isEnd(); it.next() )
  {
    if ( (*it.item()) == *pEnclosure )    // Enclosure already present.
      return;
  }

  _vpEnclosure.append( pEnclosure );

  ListenerList::ItListener itListener( _listListener.iterator() );
  for ( ; !itListener.isEnd(); itListener.next() )
    itListener.item()->enclosureAdded( *this, *pEnclosure );
}


void 
TtrEnclosureList::removeEnclosure( TtrEnclosure *pEnclosure )
{
  _vpEnclosure.remove( pEnclosure );

  ListenerList::ItListener itListener( _listListener.iterator() );
  for ( ; !itListener.isEnd(); itListener.next() )
    itListener.item()->enclosureRemoved( *this, pEnclosure );
}


void 
TtrEnclosureList::addListener( TtrEnclosureListListener *pListener )
{
  _listListener.addListener( pListener );
}


void 
TtrEnclosureList::removeListener( TtrEnclosureListListener *pListener )
{
  _listListener.removeListener( pListener );
}


ItTtrEnclosure *
TtrEnclosureList::iterator() const
{
  return new ArrayEnclosure::EIterator( _vpEnclosure );
}


void 
TtrEnclosureList::clear()
{
  _vpEnclosure.reset();
  fireRenewed();
}
