// //////////////////////////////////////////////////////////////////////////
// Implementation file TtrFmtBlank.cpp for class TtrFmtBlank
// (c)Copyright 2000, Baptiste Lepilleur.
// Created: 2000/09/15
// //////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "TtrFmtBlank.h"
#include "TtrFmtEltVisitor.h"


TtrFmtBlank::TtrFmtBlank()
{
}


TtrFmtBlank::TtrFmtBlank( const TtrFmtIndentInfo &infoIndent,
                          const TtrTextLineFormat &format ) :
    _infoIndent( infoIndent )
{
  addLine( format );
}


TtrFmtBlank::~TtrFmtBlank()
{
}


TtrFmtElt::EltType 
TtrFmtBlank::type() const
{
  return eltBlank;
}


void 
TtrFmtBlank::visit( TtrFmtEltVisitor &visitor )
{
  visitor.visitBlank( *this );
}


void 
TtrFmtBlank::addLine( const TtrTextLineFormat &format )
{
  _formats.push_back( format );
}


bool 
TtrFmtBlank::operator ==( const TtrFmtBlank &cmpTo ) const
{
  return _infoIndent == cmpTo._infoIndent  &&  
         _formats == cmpTo._formats;
}


bool 
TtrFmtBlank::operator !=( const TtrFmtBlank &cmpTo ) const
{
  return !( *this == cmpTo );
}


SL 
TtrFmtBlank::lineCount() const
{
  return _formats.size();
}
