// //////////////////////////////////////////////////////////////////////////
// Header file TtrFmtTextDumper.h for class TtrFmtTextDumper
// (c)Copyright 2000, Baptiste Lepilleur.
// Created: 2001/04/07
// //////////////////////////////////////////////////////////////////////////
#ifndef TTRFMTTEXTDUMPER_H
#define TTRFMTTEXTDUMPER_H

#include "TtrFmtEltVisitor.h"
class TtrFmtText;

/*! \class TtrFmtTextDumper
 * \brief This class dumps a formatted text (for debuging).
 */
class TtrFmtTextDumper : public TtrFmtEltVisitor
{
public:
  static void dump( const TtrFmtText &text, 
                    const EString &strTitle = "" );

private:
  /*! Constructs a TtrFmtTextDumper object.
   */
  TtrFmtTextDumper();

  /*! Destructor.
   */
  virtual ~TtrFmtTextDumper();

  /*! Visits a blank block.
   * @param blank Blank block.
   */
  virtual void visitBlank( TtrFmtBlank &blank );

  /*! Visits a paragraph.
   * @param para Paragraph.
   */
  virtual void visitPara( TtrFmtPara &para );

private:
  /*! Prevents the use of the copy constructor.
   */
  TtrFmtTextDumper( const TtrFmtTextDumper &copy );

  /*! Prevents the use of the copy operator.
   */
  TtrFmtTextDumper &operator =( const TtrFmtTextDumper &copy );

private:
};



// Inlines methods for TtrFmtTextDumper:
// -------------------------------------



#endif  // TTRFMTTEXTDUMPER_H
