// TtrGlobalSettingAccess.h: interface for the TtrGlobalSettingAccess class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TTRGLOBALSETTINGACCESS_H__A1319EEB_B1CB_41C2_B436_4C0B282B6427__INCLUDED_)
#define AFX_TTRGLOBALSETTINGACCESS_H__A1319EEB_B1CB_41C2_B436_4C0B282B6427__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class TtrGlobalSetting;

/*!
 * \brief This class provides access to the current instance of the global setting.
 */
class TtrGlobalSettingAccess
{
public:
  /*!
   * Get the global setting.
   * The global setting must have been initialized using setGlobalSetting().
   * @return Global setting.
   */
  static TtrGlobalSetting &getGlobalSetting();
  
  /*!
   * Set the global setting.
   * @param pGlobalSetting Pointer on the global setting. Must not be \c NULL.
   */
  static void setGlobalSetting( TtrGlobalSetting *pGlobalSetting );

private:
  /*!
   * Prevent instancing that object.
   */
	TtrGlobalSettingAccess();
	~TtrGlobalSettingAccess();

  /*!
   * Pointer on the global setting.
   */
/** @supplierCardinality 1*/
  static TtrGlobalSetting *_pGlobalSetting;
};



// Implementation of TtrGlobalSettingAccess
// ----------------------------------------
inline TtrGlobalSetting &
TtrGlobalSettingAccess::getGlobalSetting()
{
  EASSERT( _pGlobalSetting );
  return *_pGlobalSetting;
}


#endif // !defined(AFX_TTRGLOBALSETTINGACCESS_H__A1319EEB_B1CB_41C2_B436_4C0B282B6427__INCLUDED_)
