// TtrTextLineFormat.cpp: implementation of the TtrTextLineFormat class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ttr.h"
#include "TtrTextLineFormat.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TtrTextLineFormat::TtrTextLineFormat() :
    _isCentered( false )
{

}

TtrTextLineFormat::~TtrTextLineFormat()
{

}


bool 
TtrTextLineFormat::isCentered() const
{
  return _isCentered;
}


TtrTextLineFormat &
TtrTextLineFormat::centerOn()
{
  _isCentered = true;
  return *this;
}


TtrTextLineFormat &
TtrTextLineFormat::centerOff()
{
  _isCentered = false;
  return *this;
}


std::string 
TtrTextLineFormat::toString()
{
  return isCentered() ? "<centered>" : "<none>";
}


bool operator ==( const TtrTextLineFormat &format1,
                  const TtrTextLineFormat &format2 )
{
  return format1.isCentered() == format2.isCentered();
}


bool operator !=( const TtrTextLineFormat &format1,
                  const TtrTextLineFormat &format2 )
{
  return !( format1 == format2 );
}
