// //////////////////////////////////////////////////////////////////////////
// Header file TtrTextWriterWrappedTxt.h for class TtrTextWriterWrappedTxt
// (c)Copyright 2000, Baptiste Lepilleur.
// Created: 2000/10/04
// //////////////////////////////////////////////////////////////////////////
#ifndef TTRTEXTWRITERWRAPPEDTXT_H
#define TTRTEXTWRITERWRAPPEDTXT_H

#include "TtrTextWriter.h"


/*! \class TtrTextWriterWrappedTxt
 * \brief This class manages the writing of a wrapped text.
 */
class TtrTextWriterWrappedTxt : public TtrTextWriter
{
public:
  /*! Constructs a TtrTextWriterWrappedTxt object.
   */
  TtrTextWriterWrappedTxt();

  /*! Destructor.
   */
  virtual ~TtrTextWriterWrappedTxt();

  virtual void writeText( TtrWriterSetting &setting, 
                          TtrFormatSetting &settingFormat, 
                          TtrText &text,           
                          EIODevice &device,
                          EwgProgressInfo &progress );

private:
  /*! Prevents the use of the copy constructor.
   */
  TtrTextWriterWrappedTxt( const TtrTextWriterWrappedTxt &copy );

  /*! Prevents the use of the copy operator.
   */
  TtrTextWriterWrappedTxt &operator =( const TtrTextWriterWrappedTxt &copy );

private:
};



// Inlines methods for TtrTextWriterWrappedTxt:
// --------------------------------------------



#endif  // TTRTEXTWRITERWRAPPEDTXT_H
