// //////////////////////////////////////////////////////////////////////////
// Header file TtrUtFmtTextBuilder.h for class TtrUtFmtTextBuilder
// (c)Copyright 2000, Baptiste Lepilleur.
// Created: 2001/04/29
// //////////////////////////////////////////////////////////////////////////
#ifndef TTRUTFMTTEXTBUILDER_H
#define TTRUTFMTTEXTBUILDER_H

#include "cppunit.h"

class TtrFmtText;
class TtrFmtTextBuilder;
class TtrGlobalSetting;

/*! \class TtrUtFmtTextBuilder
 * \brief This class represents a test case for TtrFmtTextBuilder.
 */
class TtrUtFmtTextBuilder : public CppUnit::TestCase
{
public:
  /*! Constructs a TtrUtFmtTextBuilder object.
   */
  TtrUtFmtTextBuilder();

  /*! Destructor.
   */
  virtual ~TtrUtFmtTextBuilder();

  static CppUnit::TestSuite *suite();

  virtual void setUp();
  virtual void tearDown();

  void testChangeLevel0();
  void testChangeLevel2();

  void testIsTextEmpty();

  void testAddBlankToText();
  void testAddIndentedParagraphToText();
  void testAddPrefixedParagraphToText();

  void testNewBlock();
  void testAppendToBlock();
  void testAppendToBlockUsingHyphenRule();
  void testEndBlockForPara();
  void testEndBlockForBlank();

  void testJumpOneLine();

private:
  void addIndentedAndCenteredNewBlock( TtrFmtTextBuilder *pBuilder );

  /// Prevents the use of the copy constructor.
  TtrUtFmtTextBuilder( const TtrUtFmtTextBuilder &copy );

  /// Prevents the use of the copy operator.
  void operator =( const TtrUtFmtTextBuilder &copy );

private:
  TtrFmtText *_pText;
  TtrGlobalSetting *_pSetting;
  TtrGlobalSetting *_pSettingJumpLine;
  TtrFmtTextBuilder *_pBuilder;
  TtrFmtTextBuilder *_pBuilderJumpLine;
};



// Inlines methods for TtrUtFmtTextBuilder:
// ----------------------------------------



#endif  // TTRUTFMTTEXTBUILDER_H
